<?php

/* LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.

*/

add_action( 'init', array( 'Scarcity_Samurai_Endpoints', 'init' ) );

class Scarcity_Samurai_Endpoints
{
	public static function init() {
		// endpoints that aren't ajax...
		add_filter( 'query_vars', array( __CLASS__, 'add_endpoint_query_var' ) );
		add_action( 'template_redirect', array( __CLASS__, 'endpoint' ) );

		// ajax hooks
		add_action( 'wp_ajax_ss_publish_pages', array( __CLASS__, 'publish_pages' ) );
		add_action( 'wp_ajax_ss_wizard_evergreen_optin', array( __CLASS__, 'wizard_evergreen_optin' ) );
		add_action( 'wp_ajax_ss_wizard_fixed_date_multi', array( __CLASS__, 'wizard_fixed_date_multi' ) );
		add_action( 'wp_ajax_ss_wizard_evergreen_pageload', array( __CLASS__, 'wizard_evergreen_pageload' ) );
		add_action( 'wp_ajax_ss_wizard_fixed_date_single', array( __CLASS__, 'wizard_fixed_date_single' ) );
	}

	// ---------------
	//    Endpoints
	// ---------------

	public static function add_endpoint_query_var( $vars ) {
		$vars[] = 'ss-endpoint';
		return $vars;
	}

	public static function endpoint() {
		$endpoint = get_query_var( 'ss-endpoint' );
		$endpoint_file = plugin_dir_path( __FILE__ ) . "endpoints/{$endpoint}.php";

		if ( $endpoint && file_exists( $endpoint_file ) ) {
			include( $endpoint_file );
			exit;
		}
	}

	// ------------------
	//    AJAX Actions
	// ------------------

	public static function publish_pages() {
		include( plugin_dir_path( __FILE__ ) . 'endpoints/publish_pages.php' );
	}

	public static function wizard_evergreen_optin() {
		include( plugin_dir_path( __FILE__ ) . 'endpoints/wizards/evergreen_optin.php' );
	}

	public static function wizard_fixed_date_multi() {
		include( plugin_dir_path( __FILE__ ) . 'endpoints/wizards/fixed_date_multi.php' );
	}

	public static function wizard_evergreen_pageload() {
		include( plugin_dir_path( __FILE__ ) . 'endpoints/wizards/evergreen_pageload.php' );
	}

	public static function wizard_fixed_date_single() {
		include( plugin_dir_path( __FILE__ ) . 'endpoints/wizards/fixed_date_single.php' );
	}
}
