<?php

/* LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.

*/

function error() {
	header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
	exit;
}

function check_params($params) {
	if (!array_key_exists('counter_id', $params)) {
		error();
	}

	$counter = Scarcity_Samurai_Model::get( 'Counter' )->find( $params['counter_id'] );

	if ($counter === null) {
		error();
	}
}

require_once('../../../../wp-load.php');

$cache_time = 5; // Cache GIF for 5 seconds
$cache_filename = sys_get_temp_dir() . '/scarcity_samurai_counter_cache.gif';

$params = Scarcity_Samurai_Helper::get_request('params');
$params = Scarcity_Samurai_GIF_Generator_Helper::decode_params($params);

if ($params === null) {
	error();
}

check_params($params);

header('Content-type: image/gif');

if (($params['cache'] === true) && file_exists($cache_filename) &&
    (time() - filemtime($cache_filename) < $cache_time)) {
	readfile($cache_filename);
	exit;
}

require_once('../gif-generator/counter-gif-generator.php');

$counter_gif_generator = new Scarcity_Samurai_Counter_GIF_Generator($params);

if ($counter_gif_generator->is_empty()) {
	// Transparent 1x1 GIF
	// See: http://stackoverflow.com/a/3203394/247243
	echo base64_decode('R0lGODlhAQABAJAAAP8AAAAAACH5BAUQAAAALAAAAAABAAEAAAICBAEAOw==');
} else {
	$counter_gif = $counter_gif_generator->get_gif();

	// Cache the GIF
	file_put_contents($cache_filename, $counter_gif, LOCK_EX);

	// Output the GIF
	echo $counter_gif;
}
