<?php

/* LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.

*/

require_once('../../../../wp-load.php');

if (!check_ajax_referer('get_counter', 'security_token', false)) {
	exit;
}

$counter_id = Scarcity_Samurai_Helper::get_request('id');
$counter = Scarcity_Samurai_Model::get( 'Counter' )->find($counter_id);

if ($counter === null) {
	exit;
}

$page_id = intval(Scarcity_Samurai_Helper::get_request('page_id'));
$show_from = Scarcity_Samurai_Page::counter_show_from($page_id);
$display_value = Scarcity_Samurai_Counter::get_display_value_by_id($counter['id'], $show_from);

if (Scarcity_Samurai_Counter::expired($counter)) {
	$redirect_url = Scarcity_Samurai_Page::counter_redirect_url($page_id);

	echo json_encode(array(
		'status' => 'expired',
		'display_value' => $display_value, // In case there is no redirect url
		'redirect_url' => $redirect_url
	));
} else {
	echo json_encode(array(
		'status' => 'ok',
		'display_value' => $display_value
	));
}
