<?php

/* LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.

*/

require_once('../../../../wp-load.php');
require_once('../gif-generator/gif-generator-helper.php');

if (!check_ajax_referer('edit_campaign', 'security_token', false)) {
	exit;
}

function get_timestamp($value, $timezone) {
	date_default_timezone_set($timezone);
	$timezone_offset = intval(date("Z"));

	return $value - $timezone_offset;
}

$params = array();

$page_id = Scarcity_Samurai_Helper::get_request('page_id');
$deadline = Scarcity_Samurai_Helper::get_request('deadline');
$timezone = Scarcity_Samurai_Helper::get_request('timezone');
$time = Scarcity_Samurai_Helper::get_request('time');
$lifetime = Scarcity_Samurai_Helper::get_request('lifetime');
$timer_color = Scarcity_Samurai_Helper::get_request('timer_color');
$text = Scarcity_Samurai_Helper::get_request('text');

if ($page_id !== '') {
	$params['page_id'] = intval($page_id);
	$params['cache'] = true;
} else {
	$params['cache'] = false;
}

if ($deadline !== '') {
	$params['deadline'] = get_timestamp($deadline, $timezone);
}

if ($time !== '') {
	$params['time'] = $time;
}

if ($timer_color !== '') {
	$params['timer_color'] = $timer_color;
}

if ($lifetime !== '') {
	$params['lifetime'] = intval($lifetime);
}

if ($text === '') {
	$params['text'] = null;
} else {
	$params['text'] = $text;
}

$link = Scarcity_Samurai_GIF_Generator_Helper::timer_link($params);

echo json_encode($link);
