<?php

/* LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.

*/

require_once('../../../../wp-load.php');

$result = Scarcity_Samurai_Security::verify_counters_cookie();

if ($result === false) {
	exit;
}

list($guid, $ip) = $result;

$access_record = Scarcity_Samurai_Model::get( 'Counters_Access' )->find_by( array( 'id' => $guid, 'ip' => $ip ) );

$counter_id = Scarcity_Samurai_Helper::get_request('id');
$counter = Scarcity_Samurai_Model::get( 'Counter' )->find( $counter_id );

if ($counter === null) {
	exit;
}

if ($access_record === null) {
	// Increment the counter
	Scarcity_Samurai_Model::( 'Counter' )->update( array( 'value' => $counter['value'] + 1), $wpdb->prepare('id = %s', $counter_id ) );

	// Add counter access record
	Scarcity_Samurai_Model( 'Counters_Access' )->insert( array(
		'id' => $guid,
		'ip' => $ip,
		'created_at' => time(),
		'counter_id' => $counter_id
	));
}

// Redirect to the Thank You page
Scarcity_Samurai_Helper::redirect_with_args($counter['data']['thank_you_page']);
