<?php
	global $scarcity_samurai_dir;

	if ( $edit_page ) {
?>
<a name="ss-campaign"></a>
<h2>Campaign</h2>
<p>
	Which campaign this page belongs to?
</p>
<p>
	<select class="ss-page-campaign ss-campaign-select" name="ss-page-campaign">
		<option value="">No Campaign</option>
		<?php
			foreach ($campaigns as $campaign) {
				$selected = selected($campaign['id'], $page['campaign_id'], false);
				echo "<option value='" . $campaign['id'] . "' $selected>" . $campaign['name'] . '</option>';
			}
		?>
	</select>
	&nbsp;
	<!--<a href="#" onclick="alert('TODO: campaign creator'); return false">Create New Campaign</a>-->
</p>
<div class="ss-page-campaign-page-opts">
<?php } ?>

<h2>Page Purpose</h2>
<p>
	Each page in your campaign may have a different purpose. Your users will
	generally enter your campaign through a 'Sign Up' or 'Squeeze' page, view one
	or more pages of 'Content', before viewing the 'Offer' page.
</p>
<p>
	<select class="ss-page-type-id" name="ss-page-type-id">
		<?php
			$page_types = Scarcity_Samurai_Model::get( 'Page_Type' )->all();

			foreach ($page_types as $page_type) {
				$selected = selected($page_type['id'], $page['type_id'], false);
				echo "<option value='" . $page_type['id'] . "' $selected>" . $page_type['name'] . "</option>";
			}
		?>
	</select>
</p>

<p>
	<label>
		<?php
			$checked = Scarcity_Samurai_Page::contains_opt_in_form($page);
		?>
		<input class="ss-page-optin" type="checkbox" name="ss-page-optin" <?php checked($checked); ?>>
		Page contains an opt-in form
	</label>
</p>

<div class="ss-page-optin-message-wrapper <?php echo (Scarcity_Samurai_Page::contains_opt_in_form($page) ? '' : 'ss-hidden'); ?>">
<?php	if ($auto_responder === null) { ?>
				<div class="ss-page-optin-message ss-warning">
					<p>
						We were unable to detect an opt-in form on this page:
						<?php Scarcity_Samurai_Auto_Responder_Integrator::supported_auto_responders_message(); ?>
					</p>
				</div>
<?php } else { ?>
				<div class="ss-page-optin-message ss-notice">
					<p>
						<strong><?php echo $auto_responder_short_name; ?></strong> opt-in form found.
					</p>
					<p>
						For your campaign to function properly you just need to configure
						<?php echo $auto_responder_short_name; ?> to work with
						Scarcity Samurai. This only takes a couple of minutes	and you can
						see step-by-step instructions on how to do this here:
						<?php echo Scarcity_Samurai_Auto_Responder_Integrator::get_auto_responder_configuration_instructions_link($auto_responder); ?>
					</p>
				</div>
<?php } ?>
</div>

<div class="ss-page-options-div">
	<ul id="ss-page-tabs">
		<li class="ss-page-lock-tab tabs"><a name="ss-page-lock" href="#ss-page-lock">Access Restriction</a></li>
		<li class="ss-page-timer-tab hide-if-no-js"><a name="ss-page-timer" href="#ss-page-timer">Count Down Timer</a></li>
		<!-- <li class="ss-page-counter-tab hide-if-no-js"><a href="#ss-page-counter">Item Counter</a></li> -->
		<li class="ss-page-banners-tab hide-if-no-js"><a name="ss-page-banners" href="#ss-page-banners">Banners</a></li>
	</ul>

	<?php
		include($scarcity_samurai_dir . 'html/page-meta-box/access-restriction.php');
		include($scarcity_samurai_dir . 'html/page-meta-box/count-down-timer.php');
		// include($scarcity_samurai_dir . 'html/page-meta-box/item-counter.php');
		include($scarcity_samurai_dir . 'html/page-meta-box/banners.php');
	?>
</div>

<?php if ( $edit_page ) { ?>
</div>
<?php } ?>
