<div class="wrap">

	<div class="welcome-panel ss-welcome-panel">

		<div class="welcome-panel-background"></div>

		<div class="welcome-panel-content">

			<h3>Welcome to Scarcity Samurai!</h3>

			<p>You're just a few clicks away from supercharging your sales, your income, and your lifestyle with the most effective scarcity-based marketing system in the world...</p>

		</div>

		<?php if ( $update_url !== null ) { ?>

		<div class="welcome-panel-update-available">

			<div class="welcome-panel-update-background"></div>

			<p>There is a new version of Scarcity Samurai available. <a href="<?php echo esc_attr( $update_url ); ?>">Update now</a></p>

		</div>

		<?php } ?>

	</div>

	<div id="dashboard-widgets-wrap">

		<div id="dashboard-widgets" class="metabox-holder columns-2">

			<div class="postbox-container">

				<div id="postbox-container-1" class="meta-box-sortables">

					<div class="postbox ss-wizards">

						<h3 class="hndle nodrag"><span>Campaign Wizards</span></h3>

						<ul>

							<li class="inside">

								<img class="ss-wizard-icon" src="<?php echo Scarcity_Samurai_Helper::url('images/wizards/evergreen-optin.png'); ?>" />

								<a class="button-primary" href="<?php esc_attr_e( admin_url( 'admin.php?page=scarcitysamurai/campaign_wizards&wizard=evergreen_optin' ) ); ?>">Create &raquo;</a>

								<strong class="ss-wizard-name">Evergreen Scarcity (Multi-page campaign)</strong>

								<span class="description">

									For promotions containing a sequence of pages and emails

									that unfold over a number of days.<br />

									This type of campaign is set into motion when a user signs up to your list.

									<em>

										(e.g. When you want to make your product launch last forever)

									</em>

								</span>

							</li>

							<li class="inside">

								<img class="ss-wizard-icon" src="<?php echo Scarcity_Samurai_Helper::url('images/wizards/fixed-date-multi.png'); ?>" />

								<a class="button-primary" href="<?php esc_attr_e( admin_url( 'admin.php?page=scarcitysamurai/campaign_wizards&wizard=fixed_date_multi' ) ); ?>">Create &raquo;</a>

								<strong class="ss-wizard-name">Fixed Date Scarcity (Multi-page campaign)</strong>

								<span class="description">

									For promotions containing a sequence of pages and emails

									over a number of days.<br />

									This type of promotion has a specific lifespan.

									<em>

										(e.g. for a special launch promotion, such as a 50%

										discount in the first week)

									</em>

								</span>

							</li>

							<li class="inside">

								<img class="ss-wizard-icon" src="<?php echo Scarcity_Samurai_Helper::url('images/wizards/evergreen-pageload.png'); ?>" />

								<a class="button-primary" href="<?php esc_attr_e( admin_url( 'admin.php?page=scarcitysamurai/campaign_wizards&wizard=evergreen_pageload' ) ); ?>">Create &raquo;</a>

								<strong class="ss-wizard-name">Evergreen Scarcity (Single page campaign)</strong>

								<span class="description">

									For promotions containing only one page.<br />

									This type of campaign is set into motion when a user visits your page.

									<em>

										(e.g. When someone visits your squeeze page, sales page,

										survey page, competition page etc)

									</em>

								</span>

							</li>

							<li class="inside">

								<img class="ss-wizard-icon" src="<?php echo Scarcity_Samurai_Helper::url('images/wizards/fixed-date-single.png'); ?>" />

								<a class="button-primary" href="<?php esc_attr_e( admin_url( 'admin.php?page=scarcitysamurai/campaign_wizards&wizard=fixed_date_single' ) ); ?>">Create &raquo;</a>

								<strong class="ss-wizard-name">Fixed Date Scarcity (Single page campaign)</strong>

								<span class="description">

									For promotions containing a single page.<br />

									This style of	scarcity can be used for limited-time offers which have a	fixed time period.

									<em>

										(e.g. Christmas specials, Black Friday deals - deals which

										must expire at a fixed time)

									</em>

								</span>

							</li>

						</ul>

					</div>

				</div>

			</div>

			<div id="postbox-container-2" class="postbox-container">

				<div class="meta-box-sortables">

					<div class="postbox">

						<h3 class="hndle nodrag"><span>Getting Started</span></h3>

						<div class="inside">

							<div class="ss-video">

								<iframe src="//www.youtube.com/embed/dGbcZERpT6o?wmode=opaque" frameborder="0"></iframe>

							</div>

							<br />

							<div class="ss-video">

								<iframe src="//www.youtube.com/embed/6lsNfYnNyZ4?wmode=opaque" frameborder="0"></iframe>

							</div>

							<br />

							<div class="ss-video">

								<iframe src="//www.youtube.com/embed/RTLwVQv-Qlo?wmode=opaque" frameborder="0"></iframe>

							</div>

							<br />

							<div class="ss-video">

								<iframe src="//www.youtube.com/embed/PxWye9TG1oA?wmode=opaque" frameborder="0"></iframe>

							</div>

						</div>

					</div>

				</div>

			</div>

			<div class="clear"></div>

		</div>

	</div>

</div>

