<div class="wrap ss-wizard-page">
	<div id="ss-logo" class="icon32"></div>
	<h2>Evergreen Scarcity (Multi-page campaign) Setup</h2>

	<br />
	<div class="menu-edit">
		<?php wp_nonce_field('evergreen-optin-wizard', 'security_token'); ?>

		<!-- Progress Bar -->
		<div id="nav-menu-header">
			<ul class="scarcity-samurai-wizard-progress-bar">
				<li>Campaign Name</li>
				<li>Page Selection</li>
				<li>Offer Page Expiry</li>
				<li>Visualize Scarcity</li>
			</ul>
			<div class="clear"></div>
		</div>

		<!-- Wizard pages -->
		<div id="post-body" class="scarcity-samurai-wizard-content">
			<!--
				Campaign Name
			-->
			<div>
				<h3>Campaign Name</h3>
				<div class="ss-error ss-wizard-validation-errors">
					<p>
						Please fix the following errors:
					</p>
					<ul class="ul-square"></ul>
				</div>
				<p>
					<strong>What should your campaign be called?</strong>
				</p>
				<p class="ss-sub">
					<input class="ss-wizard-campaign-name ss-text-input" type="text" name="ss-wizard-evergreen-optin-campaign-name" />
				</p>
			</div>

			<!--
				Page Selection
			-->
			<div>
				<h3>Page Selection</h3>
				<div class="ss-error ss-wizard-validation-errors">
					<p>
						Please fix the following errors:
					</p>
					<ul class="ul-square"></ul>
				</div>
				<p>
					Select the pages that make up your campaign.
				</p>
				<br />

				<!-- Squeeze page -->
				<p>
					<strong>Your signup (squeeze) page:</strong>
				</p>
				<p class="ss-sub ss-page-select-wrapper">
					<?php
						Scarcity_Samurai_Helper::page_select( array(
							'name' => 'ss-wizard-evergreen-optin-squeeze-page-id',
							'in_campaign' => false
						) );

						Scarcity_Samurai_Dialogs::create_new_page_link();
					?>
				</p>
				<br />

				<!-- Content pages -->
				<p>
					<strong>Your content page(s):</strong> (optional)
				</p>
				<div class="ss-sub scarcity-samurai-wizard-content-pages-wrapper">
					<p class="ss-page-select-template ss-hidden">
						<?php
							Scarcity_Samurai_Helper::page_select( array(
								'name' => 'ss-wizard-evergreen-optin-content-page-id',
								'in_campaign' => false
							) );

							Scarcity_Samurai_Dialogs::create_new_page_link();
						?>

						<span class='ss-wizard-evergreen-optin-remove-content-page'>
							&nbsp;
							<a href='#'>Remove</a>
						</span>
					</p>
					<p class="ss-page-select-wrapper">
						<?php
							Scarcity_Samurai_Helper::page_select( array(
								'name' => 'ss-wizard-evergreen-optin-content-page-id',
								'in_campaign' => false
							) );

							Scarcity_Samurai_Dialogs::create_new_page_link();
						?>

						<span class='ss-wizard-evergreen-optin-remove-content-page'>
							&nbsp;
							<a href='#'>Remove</a>
						</span>
					</p>
				</div>
				<br />

				<!-- Offer page -->
				<p>
					<strong>Your offer (sales) page:</strong>
				</p>
				<p class="ss-sub ss-page-select-wrapper">
					<?php
						Scarcity_Samurai_Helper::page_select( array(
							'name' => 'ss-wizard-evergreen-optin-offer-page-id',
							'in_campaign' => false
						) );

						Scarcity_Samurai_Dialogs::create_new_page_link();
					?>
				</p>
			</div>

			<!--
				Offer Page Expiry
			-->
			<div>
				<h3>Set Offer Page Expiry</h3>
				<div class="ss-error ss-wizard-validation-errors">
					<p>
						Please fix the following errors:
					</p>
					<ul class="ul-square"></ul>
				</div>
				<p>
					You must set an expiry time for Scarcity Samurai to close your offer automatically.
				</p>
				<br />
				<p>
					<strong>How long after a user signs up would you like this page to expire?</strong>
				</p>
				<p class="ss-sub">
					<input class="ss-days-input ss-text-input" type="number" name="ss-wizard-evergreen-optin-days" min="0" size="2" value="0" /> days,
					<input class="ss-hours-input ss-text-input" type="number" name="ss-wizard-evergreen-optin-hours" min="0" max="23" size="2" value="0" /> hours,
					<input class="ss-minutes-input ss-text-input" type="number" name="ss-wizard-evergreen-optin-minutes" min="0" max="59" size="2" value="0" /> mins,
					<input class="ss-seconds-input ss-text-input" type="number" name="ss-wizard-evergreen-optin-seconds" min="0" max="59" size="2" value="0" /> secs
				</p>
				<br />
				<p>
					<strong>What should happen when your timer reaches zero?</strong>
				</p>
				<ul class="ul-radio">
					<li>
						<label>
							<input type="radio" class="ul-radio" name="ss-wizard-evergreen-optin-timer-expired" value='do_nothing' checked="checked">
							do nothing
						</label>
					</li>
					<li>
						<label>
							<input type="radio" class="ul-radio" name="ss-wizard-evergreen-optin-timer-expired" value='redirect_to_page'>
							redirect to page
						</label>
						<div class="ss-opts">
							<p>
								<?php
									Scarcity_Samurai_Helper::page_select( array(
										'name' => 'ss-wizard-evergreen-optin-timer-expired-redirect-page-id'
									) );

									Scarcity_Samurai_Dialogs::create_new_page_link();
								?>
							</p>
						</div>
					</li>
					<li>
						<label>
							<input type="radio" class="ul-radio" name="ss-wizard-evergreen-optin-timer-expired" value='redirect_to_url' />
							redirect to URL
						</label>
						<div class="ss-opts">
							<p>
								<input class="ss-text-input" type="text" size="40" name="ss-wizard-evergreen-optin-timer-expired-redirect-url" />
							</p>
						</div>
					</li>
				</ul>
			</div>

			<!--
				Visualize Scarcity
			-->
			<div>
				<h3>Visualize Scarcity</h3>
				<div class="ss-error ss-wizard-validation-errors">
					<p>
						Please fix the following errors:
					</p>
					<ul class="ul-square"></ul>
				</div>
				<p>
					Scarcity is MOST effective when it’s kept in your visitors field of
					view at all times. Here you can specify how you would like your
					scarcity banner to look on your offer page...
				</p>
				<br />
				<p>
					<strong>Where would you like to place your banner on your page?</strong>
				</p>
				<ul class="ul-radio">
					<li>
						<label>
							<input type="radio" class="ul-radio" name="ss-wizard-evergreen-optin-banner-position" value="header" checked="checked" />
							in the header
						</label>
					</li>
					<li>
						<label>
							<input type="radio" class="ul-radio" name="ss-wizard-evergreen-optin-banner-position" value="footer" />
							in the footer
						</label>
					</li>
					<li>
						<label>
							<input type="radio" class="ul-radio" name="ss-wizard-evergreen-optin-banner-position" value="none" />
							no banner
						</label>
					</li>
				</ul>

				<div class="ss-banner-pos-opts header footer">
					<br />
					<p>
						<strong>What would you like your banner to look like?</strong>
					</p>
					<p class="ss-sub">
						<?php
						Scarcity_Samurai_Banner_Editor::banner_select( array(
							'name' => 'ss-wizard-evergreen-optin-banner-id'
						) );
						?>
					</p>
				</div>

				<div class="ss-banner-pos-opts header footer ss-wizard-evergreen-optin-banner-click-action-wrapper">
					<br />
					<p>
						<strong>
							What would you like to do when the banner is clicked?
						</strong>
					</p>
					<ul class="ul-radio">
						<li>
							<label>
								<input class="ul-radio" type="radio" name="ss-wizard-evergreen-optin-banner-action" value="do_nothing" checked="checked" />
								do nothing
							</label>
						</li>
						<li>
							<label>
								<input class="ul-radio" type="radio" name="ss-wizard-evergreen-optin-banner-action" value="redirect_to_page" />
								go to page
							</label>
							<div class="ss-opts">
								<p>
									<?php
										Scarcity_Samurai_Helper::page_select( array(
											'name' => 'ss-wizard-evergreen-optin-banner-action-redirect-page-id'
										) );

										Scarcity_Samurai_Dialogs::create_new_page_link();
									?>
								</p>
							</div>
						</li>
						<li>
							<label>
								<input class="ul-radio" type="radio" name="ss-wizard-evergreen-optin-banner-action" value="redirect_to_url" />
								go to URL
							</label>
							<div class="ss-opts">
								<p>
									<input class="ss-text-input" type="text" size="40" name="ss-wizard-evergreen-optin-banner-action-redirect-url" />
								</p>
							</div>
						</li>
					</ul>
				</div>
			</div>

			<!--
				Finished
			-->
			<div>
				<h3>You're almost finished...</h3>
				<p>
					There are just a few minor steps left to complete:
				</p>

				<div class="ss-notice ss-wizard-evergreen-optin-token-setup-instructions">
					<p>
						For your campaign to function properly you just need to configure
						<span class="auto_responder_short_name"></span> to work with Scarcity Samurai.
						This only takes a couple of minutes and you can see step-by-step
						instructions on how to do this here:
						<?php
							foreach ( Scarcity_Samurai_Auto_Responder_Integrator::supported_auto_responders() as $auto_responder ) {
								echo "
									<span class='instructions-link $auto_responder'>" .
										Scarcity_Samurai_Auto_Responder_Integrator::get_auto_responder_configuration_instructions_link( $auto_responder ) . "
									</span>
								";
							}
						?>
					</p>
					<p>
						<span class="description">
							Note: Your 'dynamic email' links for this campaign are listed below.
						</span>
					</p>
				</div>

				<div class="ss-error ss-wizard-evergreen-optin-unpublished-pages-warning">
					<p>
						<span class="single">
							The following page need to be published for this campaign to function
							correctly. &nbsp;	<a class="button">Publish This Page Now</a>
						</span>
						<span class="multiple">
							The following pages need to be published for this campaign to function
							correctly. &nbsp;	<a class="button">Publish These Pages Now</a>
						</span>
						<ul class="ul-square"></ul>
					</p>
				</div>

				<div class="ss-error ss-wizard-evergreen-optin-unable-to-detect-optin-form-on-squeeze-page">
					<p>
						We were unable to detect a signup form on the following page:
						<ul class="ul-square"></ul>
						<p class="description">
							You may still need to add the form to this page, or you may be using
							an email provider we do not yet support.
							<?php Scarcity_Samurai_Auto_Responder_Integrator::supported_auto_responders_message(); ?>
						</p>
					</p>
				</div>

				<div class="ss-wizard-evergreen-optin-page-links">
					<h3>Page Links</h3>
					<p>
						To send users to pages in this campaign using your email system,
						use the following links:
					</p>

					<h4>Squeeze Page</h4>
					<div class="ss-sub">
						<ul class="ul-checklist">
							<li class="incomplete">
								<strong class="ss-wizard-evergreen-optin-squeeze-page-title"></strong> &mdash;
								<a class="ss-wizard-evergreen-optin-squeeze-page-edit-link">Edit</a> |
								<a class="ss-wizard-evergreen-optin-squeeze-page-view-link">View</a>
								<p>
									Link:
									<input class="ss-wizard-evergreen-optin-squeeze-page-email-url ss-page-url ss-text-input" type="text" readonly="readonly" />
									&nbsp;
									<a class="button ss-wizard-evergreen-optin-copy-to-clipboard-button">Copy To Clipboard</a>
									&nbsp;
									<span class="ss-copy-to-clipboard-confirmation-message">Copied</span>
								</p>
							</li>
						</ul>
					</div>

					<div class="ss-wizard-evergreen-optin-content-pages">
						<h4>Content Pages</h4>
						<div class="ss-sub">
							<ul class="ul-checklist">
								<li class="incomplete">
									<strong class="ss-wizard-evergreen-optin-content-page-title"></strong> &mdash;
									<a class="ss-wizard-evergreen-optin-content-page-edit-link">Edit</a> |
									<a class="ss-wizard-evergreen-optin-content-page-view-link">View</a>
									<p>
										Link:
										<input class="ss-wizard-evergreen-optin-content-page-email-url ss-page-url ss-text-input" type="text" readonly="readonly" />
										&nbsp;
										<a class="button ss-wizard-evergreen-optin-copy-to-clipboard-button">Copy To Clipboard</a>
										&nbsp;
										<span class="ss-copy-to-clipboard-confirmation-message">Copied</span>
									</p>
								</li>
							</ul>
						</div>
					</div>

					<h4>Offer Page</h4>
					<div class="ss-sub">
						<ul class="ul-checklist">
							<li class="incomplete">
								<strong class="ss-wizard-evergreen-optin-offer-page-title"></strong> &mdash;
								<a class="ss-wizard-evergreen-optin-offer-page-edit-link">Edit</a> |
								<a class="ss-wizard-evergreen-optin-offer-page-view-link">View</a>
								<p>
									Link:
									<input class="ss-wizard-evergreen-optin-offer-page-email-url ss-page-url ss-text-input" type="text" readonly="readonly" />
									&nbsp;
									<a class="button ss-wizard-evergreen-optin-copy-to-clipboard-button">Copy To Clipboard</a>
									&nbsp;
									<span class="ss-copy-to-clipboard-confirmation-message">Copied</span>
								</p>
							</li>
						</ul>
					</div>
				</div>
			</div>
		</div>

		<!-- Buttons -->
		<div id="nav-menu-footer" class="scarcity-samurai-wizard-buttons">
			<a class="back button left">&laquo; Back</a>
			<a class="continue button-primary right">Continue &raquo;</a>
			<a class="finish button-primary right">Finish</a>
			<a class="view_campaign button-primary right">View Campaign</a>
			<div class="clear"></div>
		</div>
	</div>
</div>
