<?php

/* LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.

*/

class Scarcity_Samurai_Counters_Access extends Scarcity_Samurai_Model {

	public $short_name, $table_name;
	protected $fields;

	public function __construct() {
		global $wpdb;

		$this->short_name = 'counter_access';
		$this->table_name = $wpdb->prefix . 'scarcity_samurai_counters_access';

		$this->fields = array(
			'id' => array(
				'type' => 'string'
			),
			'ip' => array(
				'type' => 'string'
			),
			'created_at' => array(
				'type' => 'datetime'
			),
			'counter_id' => array(
				'type' => 'string'
			)
		);
	}

	public static function on_activate() {
		global $wpdb, $scarcity_samurai_charset_collate;

		// Max length of IP is 45. See: http://stackoverflow.com/a/7477384/247243
		self::$sql = "
			CREATE TABLE IF NOT EXISTS " . Scarcity_Samurai_Model::get( 'Counters_Access' )->table_name . " (
				id VARCHAR(32) NOT NULL,
				ip VARCHAR(45) NOT NULL,
				created_at DATETIME NOT NULL,
				counter_id VARCHAR(32) NOT NULL,
				PRIMARY KEY (id),
				FOREIGN KEY (counter_id) REFERENCES " . Scarcity_Samurai_Model::get( 'Counter' )->table_name . "(id)
			) $scarcity_samurai_charset_collate";

		$wpdb->query(self::$sql);
	}

}
