// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  jQuery(function($) {
    var Banner, BannerElement, BannerElements, BannerStyle, BannerStyles, BaseView, CollectionView, Timer, TimerStyle, TimerStyles, banner;
    banner = window.ssam.banner;
    banner.editor = function(options) {
      var controller, view;
      controller = new banner.controller.Editor(options);
      view = new banner.view.Editor({
        controller: controller
      });
      controller.on('ready', view.open, this);
      return controller;
    };
    banner.controller.Editor = (function(_super) {

      __extends(Editor, _super);

      function Editor() {
        return Editor.__super__.constructor.apply(this, arguments);
      }

      Editor.prototype.initialize = function(options) {
        var _this = this;
        _.bindAll(this);
        if (options.page != null) {
          this.page = options.page;
        }
        this.banner = new banner.model.Banner;
        this.fixedBannerStyles = new banner.model.BannerStyles([], {
          inline: false
        });
        this.inlineBannerStyles = new banner.model.BannerStyles([], {
          inline: true
        });
        this.timerStyles = new banner.model.TimerStyles;
        return $.when(this.fixedBannerStyles.fetch(), this.inlineBannerStyles.fetch(), this.timerStyles.fetch()).then(this.banner.fetch(options)).done(function() {
          _this._ready = true;
          return _this.trigger('ready');
        }).fail(function() {
          return alert('Oops... Unable to load banner editor requirements.');
        });
      };

      return Editor;

    })(Backbone.Model);
    banner.view.BaseView = BaseView = (function(_super) {

      __extends(BaseView, _super);

      function BaseView() {
        return BaseView.__super__.constructor.apply(this, arguments);
      }

      BaseView.prototype.initialize = function(options) {
        _.bindAll(this);
        if (options.controller != null) {
          return this.controller = options.controller;
        }
      };

      BaseView.prototype.render = function() {
        if (this.template != null) {
          $(this.el).html(this.template(this.data()));
        }
        return this;
      };

      BaseView.prototype.data = function() {
        return this.options;
      };

      BaseView.prototype.assign = function(selectors) {
        return _.each(selectors, function(view, selector) {
          return view.setElement($(selector, this.el)).render();
        }, this);
      };

      return BaseView;

    })(Backbone.View);
    banner.view.CollectionView = CollectionView = (function(_super) {

      __extends(CollectionView, _super);

      function CollectionView() {
        return CollectionView.__super__.constructor.apply(this, arguments);
      }

      CollectionView.prototype.viewOptions = {};

      CollectionView.prototype.initialize = function(options) {
        CollectionView.__super__.initialize.apply(this, arguments);
        this.views = [];
        if (options.view != null) {
          this.view = options.view;
        }
        if (options.viewOptions != null) {
          this.viewOptions = options.viewOptions;
        }
        if (this.model) {
          this.model.bind('reset', this.reset);
          this.model.bind('add', this.add);
          this.model.bind('remove', this.remove);
          return this.model.each(this.add);
        }
      };

      CollectionView.prototype.add = function(model) {
        var options, view;
        options = _.extend(this.viewOptions, {
          model: model,
          collection: this,
          controller: this.controller
        });
        view = new this.view(options);
        this.views.push(view);
        if (this._rendered) {
          return $(this.el).append(view.render().el);
        }
      };

      CollectionView.prototype.remove = function(model) {
        return this.views = _.filter(this.views, function(view) {
          if (this._rendered && view.model === model) {
            $(view.el, this.el).remove();
          }
          return view.model !== model;
        }, this);
      };

      CollectionView.prototype.reset = function() {
        var view, _i, _len, _ref;
        _ref = this.views;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          view = _ref[_i];
          $(view.el, this.el).remove();
        }
        this.views = [];
        this._rendered = false;
        return this.model.each(this.add);
      };

      CollectionView.prototype.render = function() {
        this._rendered = true;
        $(this.el).empty();
        _.each(this.views, function(view) {
          return $(this.el).append(view.render().el);
        }, this);
        return this;
      };

      return CollectionView;

    })(BaseView);
    banner.view.Editor = (function(_super) {

      __extends(Editor, _super);

      function Editor() {
        return Editor.__super__.constructor.apply(this, arguments);
      }

      Editor.prototype.template = banner.template('editor');

      Editor.prototype.initMaxImageWidth = 400;

      Editor.prototype.initMaxImageHeight = 60;

      Editor.prototype.events = {
        'click .ss-banner-modal-backdrop, .ss-banner-modal-close': 'closeHandler',
        'click .ss-banner-editor-menu > a': 'menuHandler',
        'click .ss-button-add-text': 'addTextHandler',
        'click .ss-button-add-image': 'addImageHandler',
        'click .ss-button-add-timer': 'addTimerHandler',
        'click .ss-button-delete': 'deleteHandler',
        'click .ss-button-save': 'saveHandler',
        'click .ss-button-save-as': 'saveAsHandler',
        'change .ss-banner-editor-option input, .ss-banner-editor-option select': 'optionChangeHandler'
      };

      Editor.prototype.initialize = function(options) {
        Editor.__super__.initialize.apply(this, arguments);
        this.bannerStylesView = new BannerStyles({
          model: this.controller.fixedBannerStyles,
          controller: this.controller
        });
        this.timerStylesView = new TimerStyles({
          model: this.controller.timerStyles,
          controller: this.controller
        });
        this.bannerView = new Banner({
          editable: true,
          bannerClass: 'ss-banner-editor-style',
          model: this.controller.banner,
          controller: this.controller
        });
        this.controller.banner.on('change:style', this.updateBannerStyle);
        return this.controller.banner.elements.on('add remove change reset', this.updateElements);
      };

      Editor.prototype.render = function() {
        Editor.__super__.render.apply(this, arguments);
        $('.color-picker-hex', this.el).wpColorPicker({
          change: this.optionChangeHandler
        });
        $('.ss-banner-editor-layout iframe', this.el).attr('src', this.controller.page);
        this.updateElements();
        this.assign({
          '.ss-banner-editor-layout .ss-banner-overlay': this.bannerView,
          '.ss-banner-editor-banner-styles': this.bannerStylesView,
          '.ss-banner-editor-timer-styles': this.timerStylesView
        });
        return this;
      };

      Editor.prototype.data = function() {
        var style;
        style = this.controller.fixedBannerStyles.get(this.controller.banner.get('style.id'));
        if (!(style != null)) {
          style = new banner.model.BannerStyle;
        }
        return style.vars(this.controller.banner);
      };

      Editor.prototype.updateBannerStyle = function() {
        var $el, attributes, key, match, value, _results;
        attributes = this.controller.banner.changedAttributes();
        _results = [];
        for (key in attributes) {
          value = attributes[key];
          match = key.match(/style\.(.*)/);
          if (match == null) {
            continue;
          }
          $el = $("[name='" + match[1] + "']", this.el);
          $el.val(value);
          if ($el.is('.color-picker-hex')) {
            _results.push($el.wpColorPicker('color', value));
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      };

      Editor.prototype.updateElements = function() {
        var hasTimer;
        hasTimer = this.controller.banner.elements.some(function(element) {
          return element.get('type') === 'timer';
        });
        return $('.ss-button-add-timer', this.el).attr('disabled', hasTimer);
      };

      Editor.prototype.open = function() {
        this.render();
        return $(this.el).appendTo(document.body);
      };

      Editor.prototype.close = function() {
        return $(this.el).detach();
      };

      Editor.prototype.closeHandler = function(event) {
        event.preventDefault();
        return this.close();
      };

      Editor.prototype.menuHandler = function(event) {
        var $frame, $target, content;
        event.preventDefault();
        $target = $(event.target);
        $target.addClass('active');
        $('.ss-banner-editor-menu > a', this.el).not($target).removeClass('active');
        content = $target.attr('data-content');
        $frame = $(".ss-banner-editor-" + content + "-frame", this.el).show();
        return $('.ss-banner-editor-content-frame', this.el).not($frame).hide();
      };

      Editor.prototype.addTextHandler = function(event) {
        event.preventDefault();
        return this.controller.banner.elements.add({
          type: "text",
          data: {
            text: "Text"
          }
        });
      };

      Editor.prototype.addImageHandler = function(event) {
        var _this = this;
        event.preventDefault();
        if (!this.mediaFileFrame) {
          this.mediaLibrary = wp.media.query({
            type: 'ss_banner_images'
          });
          this.mediaFileFrame = wp.media.frames.ss_banner_file_frame = wp.media({
            title: 'Add Banner Image',
            button: {
              text: 'Insert Image'
            },
            multiple: false,
            library: {
              type: 'image'
            }
          });
          this.mediaFileFrame.on('select', function() {
            var imageData, sizeAdjust;
            imageData = _this.mediaFileFrame.state().get('selection').first().toJSON();
            sizeAdjust = Math.min(1, _this.initMaxImageWidth / imageData.width, _this.initMaxImageHeight / imageData.height);
            return _this.controller.banner.elements.add({
              type: "image",
              data: {
                src: imageData.url,
                width: imageData.width * sizeAdjust,
                height: imageData.height * sizeAdjust
              }
            });
          });
          this.mediaFileFrame.on('close', function() {
            return $(_this.el).show();
          });
        }
        this.mediaFileFrame.open();
        return $(this.el).hide();
      };

      Editor.prototype.addTimerHandler = function(event) {
        event.preventDefault();
        if (!($(event.target).attr('disabled') != null)) {
          return this.controller.banner.elements.add({
            type: "timer"
          });
        }
      };

      Editor.prototype.deleteHandler = function(event) {
        event.preventDefault();
        if (confirm('Are you sure you want to delete this banner?')) {
          this.controller.banner.destroy({
            wait: true
          });
          return this.close();
        }
      };

      Editor.prototype.saveHandler = function(event) {
        event.preventDefault();
        if (this.controller.banner.id != null) {
          if (confirm('This will update all instances of this banner.  Are you sure?')) {
            this.controller.banner.save();
            return this.close();
          }
        } else {
          return this.saveAsHandler(event);
        }
      };

      Editor.prototype.saveAsHandler = function(event, message) {
        var name,
          _this = this;
        event.preventDefault();
        if (message != null) {
          message = "ERROR: " + message + "\n\n";
        } else {
          message = '';
        }
        name = prompt("" + message + "What name should be given to this banner?");
        if (name === null) {
          return;
        }
        if (name === '') {
          return this.saveAsHandler(event, 'Banner name cannot be empty.');
        } else {
          this.controller.banner.unset('id', {
            silent: true
          });
          this.controller.banner.set('name', name, {
            silent: true
          });
          return $.when(this.controller.banner.save()).fail(function(error) {
            return _this.saveAsHandler(event, error);
          }).done(function() {
            return _this.close();
          });
        }
      };

      Editor.prototype.optionChangeHandler = function(event) {
        var value;
        if (event.type === 'irischange') {
          value = $(event.target).wpColorPicker('color');
        } else {
          value = event.target.value;
        }
        return this.controller.banner.set("style." + event.target.name, value);
      };

      return Editor;

    })(BaseView);
    banner.view.Banner = Banner = (function(_super) {

      __extends(Banner, _super);

      function Banner() {
        return Banner.__super__.constructor.apply(this, arguments);
      }

      Banner.prototype.template = banner.template('editor-banner');

      Banner.prototype.initialize = function(options) {
        Banner.__super__.initialize.apply(this, arguments);
        this.inline = options.inline;
        this.elementsView = new BannerElements({
          editable: options != null ? options.editable : void 0,
          model: this.model.elements,
          controller: this.controller
        });
        this.model.on('change:style.id', this.updateBannerStyle);
        this.model.on('change:style', this.updateBanner);
        return this.model.on('change:elements', this.updateElements);
      };

      Banner.prototype.render = function() {
        Banner.__super__.render.apply(this, arguments);
        this.renderBanner();
        this.renderBannerCSS();
        return this;
      };

      Banner.prototype.renderBanner = function() {
        var bannerStyles, compiled, style;
        bannerStyles = this.inline ? this.controller.inlineBannerStyles : this.controller.fixedBannerStyles;
        style = bannerStyles.get(this.model.get('style.id'));
        if (!(style != null)) {
          style = new banner.model.BannerStyle;
        }
        compiled = _.template(style.get('html'), null, banner.templateOptions);
        $("." + this.options.bannerClass, this.el).html(compiled());
        return this.assign({
          '.ss-banner-content': this.elementsView
        });
      };

      Banner.prototype.renderBannerCSS = function() {
        var bannerStyles, css, style, vars;
        bannerStyles = this.inline ? this.controller.inlineBannerStyles : this.controller.fixedBannerStyles;
        style = bannerStyles.get(this.model.get('style.id'));
        if (!(style != null)) {
          style = new banner.model.BannerStyle;
        }
        css = style.css(this.model, "." + this.options.bannerClass + " ");
        $('style.ss-banner-css', this.el).remove();
        $(this.el).append($('<style class="ss-banner-css" />').text(css));
        vars = style.vars(this.model);
        return $(this.el).toggleClass('ss-banner-background-dark', banner.brightness(vars['BACKGROUND_COLOR']) > 130);
      };

      Banner.prototype.updateBanner = function() {
        return this.renderBannerCSS();
      };

      Banner.prototype.updateBannerStyle = function() {
        return this.renderBanner();
      };

      Banner.prototype.updateElements = function() {
        return this.elementsView.render();
      };

      return Banner;

    })(BaseView);
    banner.view.Timer = Timer = (function(_super) {

      __extends(Timer, _super);

      function Timer() {
        return Timer.__super__.constructor.apply(this, arguments);
      }

      Timer.prototype.template = banner.template('editor-timer');

      Timer.prototype.initialize = function(options) {
        Timer.__super__.initialize.apply(this, arguments);
        return this.timerStyleId = options.timerStyleId;
      };

      Timer.prototype.render = function() {
        Timer.__super__.render.apply(this, arguments);
        this.renderTimer();
        this.renderTimerCSS();
        return this;
      };

      Timer.prototype.renderTimer = function() {
        var style;
        style = this.controller.timerStyles.get(this.timerStyleId);
        if (!(style != null)) {
          style = new banner.model.TimerStyle;
        }
        $("." + this.options.timerClass, this.el).html(style.get('html'));
        $('.ss-timer-value', this.el).text('00');
        return this;
      };

      Timer.prototype.renderTimerCSS = function() {
        var bannerStyle, css, style;
        style = this.controller.timerStyles.get(this.timerStyleId);
        if (!(style != null)) {
          style = new banner.model.TimerStyle;
        }
        bannerStyle = this.controller.fixedBannerStyles.get(this.controller.banner.get('style.id'));
        if (!(bannerStyle != null)) {
          bannerStyle = new banner.model.BannerStyle;
        }
        css = style.css(this.controller.banner, bannerStyle, "." + this.options.timerClass + " ");
        $('style.ss-banner-css', this.el).remove();
        return $(this.el).append($('<style class="ss-timer-css" />').text(css));
      };

      return Timer;

    })(BaseView);
    banner.view.BannerElement = BannerElement = (function(_super) {

      __extends(BannerElement, _super);

      function BannerElement() {
        return BannerElement.__super__.constructor.apply(this, arguments);
      }

      BannerElement.prototype.tagName = 'div';

      BannerElement.prototype.className = 'ss-banner-element-wrapper';

      BannerElement.prototype.template = banner.template('editor-banner-element');

      BannerElement.prototype.events = {
        'click .drag .remove': 'removeHandler'
      };

      BannerElement.prototype.initialize = function(options) {
        var bannerId;
        BannerElement.__super__.initialize.apply(this, arguments);
        this.elements = options.collection;
        if (options != null ? options.editable : void 0) {
          this.template = banner.template('editor-banner-editable-element');
          this.elements.on('dragged', this._addEditor);
        }
        this.addEditor = _.throttle(this._addEditor, 1000);
        switch (this.model.get('type')) {
          case 'timer':
            bannerId = this.controller.banner.id;
            this.timerView = new Timer({
              controller: this.controller,
              timerStyleId: this.controller.banner.get('style.timer_id'),
              timerClass: "ss-banner-" + bannerId + "-timer-style"
            });
        }
        this.controller.banner.on('change', this.updateElement);
        if (!(options != null ? options.editable : void 0)) {
          return this.model.on('change', this.updateElement);
        }
      };

      BannerElement.prototype.render = function() {
        var $image, data, _ref, _ref1, _ref2,
          _this = this;
        BannerElement.__super__.render.apply(this, arguments);
        switch (this.model.get('type')) {
          case 'text':
            data = (_ref = this.model.get('data.text')) != null ? _ref.replace(/\\"/g, '"') : void 0;
            $('.ss-banner-element', this.el).html(data).attr('id', "ss-banner-element-" + this.cid);
            if ((_ref1 = this.options) != null ? _ref1.editable : void 0) {
              _.defer(this.addEditor);
            }
            break;
          case 'image':
            $image = $('<img>').attr({
              src: this.model.get('data.src')
            });
            if (this.model.has('data.width')) {
              $image.width(this.model.get('data.width'));
            }
            if (this.model.has('data.height')) {
              $image.height(this.model.get('data.height'));
            }
            $image.css({
              margin: '0 auto'
            });
            $('.ss-banner-element', this.el).empty().append($image);
            if ((_ref2 = this.options) != null ? _ref2.editable : void 0) {
              $image.on('load', function() {
                return $('img', _this.el).resizable({
                  handles: 'ne, se, sw, nw',
                  aspectRatio: true,
                  resize: function(event, ui) {
                    return $(ui.element).css({
                      top: 0,
                      left: 0
                    });
                  },
                  stop: function(event, ui) {
                    _this.model.set('data.width', ui.size.width);
                    return _this.model.set('data.height', ui.size.height);
                  }
                });
              });
            }
            break;
          case 'timer':
            this.timerView.timerStyleId = this.controller.banner.get('style.timer_id');
            this.assign({
              '.ss-banner-element': this.timerView
            });
        }
        $('.drag .remove', this.el).on('click', this.removeHandler);
        return this;
      };

      BannerElement.prototype._addEditor = function() {
        var _this = this;
        this._removeEditor();
        return tinyMCE.init({
          mode: 'exact',
          elements: "ss-banner-element-" + this.cid,
          theme: 'advanced',
          language: ssBannerEditor.language,
          theme_advanced_buttons1: 'fontselect,forecolor,bold,italic,underline,strikethrough',
          theme_advanced_buttons2: '',
          theme_advanced_buttons3: '',
          theme_advanced_buttons4: '',
          theme_advanced_toolbar_location: 'external',
          theme_advanced_statusbar_location: 'none',
          theme_advacned_resizing: false,
          relative_urls: false,
          convert_urls: false,
          fix_list_elements: true,
          paste_remove_styles: true,
          paste_remove_spans: true,
          paste_strip_class_attributes: 'all',
          paste_text_use_dialog: true,
          force_hex_style_colors: true,
          force_br_newlines: true,
          force_p_newlines: false,
          forced_root_block: '',
          setup: function(ed) {
            ed.onInit.add(_this._initEditor);
            ed.onEvent.add(_this._resizeEditor);
            ed.onExecCommand.add(_this._resizeEditor);
            ed.onKeyUp.add(_this._resizeEditor);
            return ed.onActivate.add(_this._resizeEditor);
          }
        });
      };

      BannerElement.prototype._initEditor = function(ed) {
        var key, style, value;
        style = window.getComputedStyle($("#" + ed.id, this.el).get(0));
        for (key in style) {
          value = style[key];
          if (key.match(/^color|font|line-height/)) {
            $(ed.contentDocument.body).css(key, value);
          }
        }
        ed.contentDocument.body.style.padding = 0;
        ed.contentDocument.body.style.margin = 0;
        ed.contentDocument.body.style.backgroundColor = 'transparent';
        ed.contentDocument.body.style.overflow = 'hidden';
        ed.contentDocument.body.style.whiteSpace = 'nowrap';
        this._resizeEditor();
        return $("#ss-banner-element-" + this.cid + "_external").appendTo($('.ss-banner-editor-layout-toolbar .ss-banner-editor-mce-toolbar'));
      };

      BannerElement.prototype._resizeEditor = function(ed) {
        var $block, h, w;
        ed = tinyMCE.getInstanceById("ss-banner-element-" + this.cid);
        this.model.set('data.text', ed.save());
        $block = $("#ss-banner-element-" + this.cid);
        $block.css('padding', '0 2px');
        w = Math.max(50, $block.width());
        if ($block.html() === '') {
          h = $block.text('DUMMY').height();
          $block.empty();
        } else {
          h = $block.height();
        }
        return $('iframe', ed.contentAreaContainer).css({
          height: "" + h + "px"
        }).attr('allowtransparency', 'true').closest('table').css({
          width: "" + (w + 4) + "px",
          height: "" + h + "px"
        });
      };

      BannerElement.prototype._removeEditor = function() {
        var eid;
        eid = "ss-banner-element-" + this.cid;
        if (tinyMCE.getInstanceById(eid) != null) {
          tinyMCE.execCommand('mceFocus', false, eid);
        }
        return tinyMCE.execCommand('mceRemoveControl', false, eid);
      };

      BannerElement.prototype.updateElement = function() {
        return this.render();
      };

      BannerElement.prototype.removeHandler = function(event) {
        event.preventDefault();
        this._removeEditor();
        return this.controller.banner.elements.remove(this.model);
      };

      return BannerElement;

    })(BaseView);
    banner.view.BannerElements = BannerElements = (function(_super) {

      __extends(BannerElements, _super);

      function BannerElements() {
        return BannerElements.__super__.constructor.apply(this, arguments);
      }

      BannerElements.prototype.view = BannerElement;

      BannerElements.prototype.initialize = function(options) {
        options.viewOptions = _.extend(options.viewOptions || {}, {
          editable: options != null ? options.editable : void 0
        });
        BannerElements.__super__.initialize.call(this, options);
        return this.model.on('add remove reset', this.updateElements);
      };

      BannerElements.prototype.render = function() {
        var _ref,
          _this = this;
        BannerElements.__super__.render.apply(this, arguments);
        if (!((_ref = this.options) != null ? _ref.editable : void 0)) {
          return;
        }
        return $(this.el).sortable({
          handle: '.drag',
          placeholder: 'ss-banner-element-placeholder',
          tolerance: 'pointer',
          axis: 'x',
          containment: false,
          start: function(ev, ob) {
            var top;
            _this._from = ob.item.index();
            top = ob.placeholder.offset().top - ob.item.offset().top;
            ob.item.css('top', ob.originalPosition.top);
            ob.placeholder.width(ob.item.width());
            ob.placeholder.height(ob.item.height());
            return ob.placeholder.attr('class', ob.item.attr('class')).addClass('ss-banner-element-placeholder');
          },
          stop: function(ev, ob) {
            var element, elements, i, to, _i, _j, _ref1, _ref2, _ref3, _results;
            to = ob.item.index();
            elements = [];
            for (i = _i = _ref1 = _this._from; _ref1 <= to ? _i <= to : _i >= to; i = _ref1 <= to ? ++_i : --_i) {
              elements.push(_this.model.at(i));
            }
            elements.push(elements.shift());
            _ref3 = _.object((function() {
              _results = [];
              for (var _j = _ref2 = _this._from; _ref2 <= to ? _j <= to : _j >= to; _ref2 <= to ? _j++ : _j--){ _results.push(_j); }
              return _results;
            }).apply(this), elements);
            for (i in _ref3) {
              element = _ref3[i];
              element.set('position', i);
            }
            _this.model.sort();
            return _this.trigger('dragged');
          }
        });
      };

      BannerElements.prototype.updateElements = function() {
        this.model.each(function(element, i) {
          return element.set('position', i);
        });
        return this.render();
      };

      return BannerElements;

    })(CollectionView);
    banner.view.BannerStyle = BannerStyle = (function(_super) {

      __extends(BannerStyle, _super);

      function BannerStyle() {
        return BannerStyle.__super__.constructor.apply(this, arguments);
      }

      BannerStyle.prototype.tagName = 'li';

      BannerStyle.prototype.className = 'ss-banner-editor-banner-style';

      BannerStyle.prototype.template = banner.template('editor-banner-style');

      BannerStyle.prototype.events = {
        'click .ss-banner-overlay': 'clickHandler'
      };

      BannerStyle.prototype.initialize = function(options) {
        BannerStyle.__super__.initialize.apply(this, arguments);
        this.controller.banner.on('change:style', this.updateBannerStyle);
        this.controller.banner.elements.on('add remove change reset', this.updateBannerElements);
        this.banner = new banner.model.Banner(this.controller.banner.toJSON());
        this.banner.set('style.id', this.model.id);
        return this.bannerView = new Banner({
          editable: false,
          bannerClass: "ss-banner-style-" + this.model.id,
          model: this.banner,
          controller: this.controller
        });
      };

      BannerStyle.prototype.render = function() {
        var selected, _ref;
        BannerStyle.__super__.render.apply(this, arguments);
        $('.preview-content iframe', this.el).attr('src', this.controller.page);
        selected = this.model.id.toString() === ((_ref = this.controller.banner.get('style.id')) != null ? _ref.toString() : void 0);
        $(this.el).toggleClass('selected', selected);
        this.assign({
          '.ss-banner-overlay': this.bannerView
        });
        return this;
      };

      BannerStyle.prototype.clickHandler = function(event) {
        event.preventDefault();
        return this.controller.banner.set('style.id', this.model.id);
      };

      BannerStyle.prototype.updateBannerStyle = function() {
        var attributes, selected, _ref;
        attributes = this.controller.banner.changedAttributes();
        delete attributes['style'];
        if (attributes['style.id'] != null) {
          selected = this.model.id.toString() === ((_ref = this.controller.banner.get('style.id')) != null ? _ref.toString() : void 0);
          $(this.el).toggleClass('selected', selected);
          delete attributes['style.id'];
        }
        return this.banner.set(attributes);
      };

      BannerStyle.prototype.updateBannerElements = function() {
        return this.banner.elements.reset(this.controller.banner.elements.toJSON());
      };

      return BannerStyle;

    })(BaseView);
    banner.view.BannerStyles = BannerStyles = (function(_super) {

      __extends(BannerStyles, _super);

      function BannerStyles() {
        return BannerStyles.__super__.constructor.apply(this, arguments);
      }

      BannerStyles.prototype.view = BannerStyle;

      return BannerStyles;

    })(CollectionView);
    banner.view.TimerStyle = TimerStyle = (function(_super) {

      __extends(TimerStyle, _super);

      function TimerStyle() {
        return TimerStyle.__super__.constructor.apply(this, arguments);
      }

      TimerStyle.prototype.tagName = 'li';

      TimerStyle.prototype.className = 'ss-banner-editor-timer-style';

      TimerStyle.prototype.template = banner.template('editor-timer-style');

      TimerStyle.prototype.events = {
        'click .preview': 'clickHandler'
      };

      TimerStyle.prototype.initialize = function() {
        TimerStyle.__super__.initialize.apply(this, arguments);
        this.timerView = new Timer({
          controller: this.controller,
          timerStyleId: this.model.id,
          timerClass: "ss-timer-style-" + this.model.id
        });
        return this.controller.banner.on('change:style', this.updateBanner);
      };

      TimerStyle.prototype.render = function() {
        var selected, _ref;
        TimerStyle.__super__.render.apply(this, arguments);
        selected = this.model.id.toString() === ((_ref = this.controller.banner.get('style.timer_id')) != null ? _ref.toString() : void 0);
        $(this.el).toggleClass('selected', selected);
        this.assign({
          '.preview-alignment': this.timerView
        });
        return this;
      };

      TimerStyle.prototype.clickHandler = function(event) {
        event.preventDefault();
        return this.controller.banner.set('style.timer_id', this.model.id);
      };

      TimerStyle.prototype.updateBanner = function() {
        var attributes, selected, style, vars, _ref;
        attributes = this.controller.banner.changedAttributes();
        if (attributes['style.timer_id'] != null) {
          selected = this.model.id.toString() === ((_ref = this.controller.banner.get('style.timer_id')) != null ? _ref.toString() : void 0);
          $(this.el).toggleClass('selected', selected);
        }
        this.render();
        style = this.controller.fixedBannerStyles.get(this.controller.banner.get('style.id'));
        if (!(style != null)) {
          style = new banner.model.TimerStyle;
        }
        vars = style.vars(this.controller.banner);
        return $(this.el).css('background-color', vars['BACKGROUND_COLOR'] || 'inherit');
      };

      return TimerStyle;

    })(BaseView);
    return banner.view.TimerStyles = TimerStyles = (function(_super) {

      __extends(TimerStyles, _super);

      function TimerStyles() {
        return TimerStyles.__super__.constructor.apply(this, arguments);
      }

      TimerStyles.prototype.view = TimerStyle;

      return TimerStyles;

    })(CollectionView);
  });

}).call(this);
