// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  jQuery(function($) {
    var $currentBannerSelect, $fixedBannerSelects, $inlineBannerSelects, banner, controller, fixedBanners, getFormatFunction, getFormatSelectionFunction, getSelect2Params, inlineBanners, updateSelects;
    banner = window.ssam.banner;
    fixedBanners = new banner.model.Banners({
      inline: false
    });
    inlineBanners = new banner.model.Banners({
      inline: true
    });
    controller = new banner.controller.Editor({
      page: $(this).data('page')
    });
    getFormatFunction = function(inline) {
      var banners;
      banners = inline ? inlineBanners : fixedBanners;
      return function(state, container, query) {
        var $el, markup, model, view;
        if (!state.id) {
          return state.text;
        }
        model = banners.get(state.id);
        controller.banner = model;
        view = new banner.view.Banner({
          inline: inline,
          editable: false,
          bannerClass: "ss-banner-preview-" + state.id,
          model: model,
          controller: controller
        });
        markup = [];
        Select2.util.markMatch(model.get('name'), query.term, markup, function(m) {
          return m;
        });
        $el = $('<div>').html(banner.template('select-preview')({
          title: markup.join('')
        }));
        $('.ss-banner-overlay', $el).append(view.render().el);
        return $el;
      };
    };
    getFormatSelectionFunction = function(inline) {
      var banners;
      banners = inline ? inlineBanners : fixedBanners;
      return function(state, container) {
        var model;
        if (!state.id) {
          return state.text;
        }
        model = banners.get(state.id);
        return model.get('name');
      };
    };
    getSelect2Params = function(inline) {
      return {
        width: 460,
        formatResult: getFormatFunction(inline),
        formatSelection: getFormatSelectionFunction(inline),
        escapeMarkup: function(m) {
          return m;
        },
        sortResults: function(results) {
          return results.sort(function(a, b) {
            a = a.text.toLowerCase();
            b = b.text.toLowerCase();
            if (b < a) {
              return 1;
            } else if (a < b) {
              return -1;
            } else {
              return 0;
            }
          });
        }
      };
    };
    $fixedBannerSelects = $('.ss-banner-select').filter(function() {
      return $(this).data('inline') === false;
    });
    $inlineBannerSelects = $('.ss-banner-select').filter(function() {
      return $(this).data('inline') === true;
    });
    $fixedBannerSelects.select2(getSelect2Params(false));
    $inlineBannerSelects.select2(getSelect2Params(true));
    updateSelects = function($selects) {
      return _.defer(function() {
        return $selects.each(function() {
          return $(this).select2('val', $(this).data('value'));
        });
      });
    };
    $currentBannerSelect = null;
    fixedBanners.on('add', function(banner) {
      var $newBannerOption;
      $newBannerOption = $('<option>').val(banner.id).text(banner.get('name'));
      $fixedBannerSelects.append($newBannerOption);
      return updateSelects($fixedBannerSelects);
    });
    inlineBanners.on('add', function(banner) {
      var $newBannerOption;
      $newBannerOption = $('<option>').val(banner.id).text(banner.get('name'));
      $inlineBannerSelects.append($newBannerOption);
      return updateSelects($inlineBannerSelects);
    });
    fixedBanners.on('remove', function(banner) {
      var firstValue;
      $fixedBannerSelects.find("[value='" + banner.id + "']").remove();
      firstValue = $currentBannerSelect.find('option:first-child').attr('value');
      return $currentBannerSelect.select2('val', firstValue);
    });
    inlineBanners.on('remove', function(banner) {
      var firstValue;
      $inlineBannerSelects.find("[value='" + banner.id + "']").remove();
      firstValue = $currentBannerSelect.find('option:first-child').attr('value');
      return $currentBannerSelect.select2('val', firstValue);
    });
    $.when(fixedBanners.fetch()).done(function() {
      return updateSelects($fixedBannerSelects);
    });
    $.when(inlineBanners.fetch()).done(function() {
      return updateSelects($inlineBannerSelects);
    });
    return $fixedBannerSelects.each(function() {
      var $link,
        _this = this;
      $link = $('<a>').addClass('ss-banner-select-customize').attr('href', '#').text('Customize Banner');
      $link.on('click', function(event) {
        var editor;
        event.preventDefault();
        $currentBannerSelect = $(_this);
        editor = banner.editor({
          page: $(_this).data('page'),
          id: _this.value
        });
        top._E = editor;
        editor.banner.on('created', function(data) {
          $currentBannerSelect.data('value', data.id);
          return fixedBanners.add(new banner.model.Banner(data));
        });
        editor.banner.on('updated', function(data) {
          return fixedBanners.get(data.id).set(data).elements.reset(data.elements);
        });
        return editor.banner.on('deleted', function(data) {
          $currentBannerSelect.data('value', null);
          return fixedBanners.remove(fixedBanners.get(data.id));
        });
      });
      return $(this).after($link);
    });
  });

}).call(this);
