// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  jQuery(function($) {
    var ScarcitySamuraiCounter, counter, counterData, counterElementId, counterId, counters, endpoint, getCounter, pageId, securityParams, updateCounters, updateFrequency, _ref;
    ScarcitySamuraiCounter = (function() {

      function ScarcitySamuraiCounter(counterElementId, counterData) {
        this.updateUI = __bind(this.updateUI, this);
        this.$counterWrapper = $(".ss-counter-" + counterElementId);
        this.innerWrapper = $('.ss-counter-inner', this.$counterWrapper);
        this.styled = this.$counterWrapper.is('.ss-styled-counter');
        this.counterId = counterData['counter_id'];
      }

      ScarcitySamuraiCounter.prototype.updateUI = function(result) {
        var $digitWrapper, counterText, digits, digitsCount, i, _i, _ref;
        if (this.styled) {
          digits = result.display_value.toString().split('');
          digitsCount = digits.length;
          if ((this.digits != null) && (digitsCount === this.digits)) {
            $('.ss-counter-digit-wrapper .ss-counter-digit-value', this.$counterWrapper).each(function(index) {
              $(this).text(digits[index]);
            });
          } else {
            $digitWrapper = $('.ss-counter-digit-wrapper', this.$counterWrapper).eq(0).clone();
            this.innerWrapper.empty();
            for (i = _i = 0, _ref = digitsCount - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
              this.innerWrapper.append($digitWrapper.clone().find('.ss-counter-digit-value').text(digits[i]).parents('.ss-counter-digit-wrapper'));
            }
            this.digits = digitsCount;
          }
        } else {
          counterText = result.display_value;
          this.$counterWrapper.text(counterText);
        }
        this.$counterWrapper.show();
        if (result.status === 'expired' && (result.redirect_url != null)) {
          window.location = result.redirect_url;
        }
      };

      return ScarcitySamuraiCounter;

    })();
    updateFrequency = 10000;
    pageId = scarcitySamuraiData.page_id;
    endpoint = scarcitySamuraiData.get_counter_endpoint;
    securityParams = {
      security_token: scarcitySamuraiData.counters_security_token,
      _wp_http_referer: scarcitySamuraiData.counters_wp_http_referer
    };
    counters = {};
    if (scarcitySamuraiData.counter != null) {
      _ref = scarcitySamuraiData.counter;
      for (counterElementId in _ref) {
        counterData = _ref[counterElementId];
        counter = new ScarcitySamuraiCounter(counterElementId, counterData);
        counterId = counterData['counter_id'];
        if (counters[counterId] != null) {
          counters[counterId].push(counter);
        } else {
          counters[counterId] = [counter];
        }
      }
    }
    getCounter = function(counterId) {
      var params;
      params = {
        id: counterId,
        page_id: pageId
      };
      params = _.extend(params, securityParams);
      return $.ajax({
        type: "POST",
        url: endpoint,
        data: params,
        dataType: 'json'
      });
    };
    updateCounters = function() {
      var counterObjects, _results;
      _results = [];
      for (counterId in counters) {
        counterObjects = counters[counterId];
        _results.push((function(counterId, counterObjects) {
          return $.when(getCounter(counterId)).done(function(result) {
            var counterObject, _i, _len, _results1;
            _results1 = [];
            for (_i = 0, _len = counterObjects.length; _i < _len; _i++) {
              counterObject = counterObjects[_i];
              _results1.push(counterObject.updateUI(result));
            }
            return _results1;
          });
        })(counterId, counterObjects));
      }
      return _results;
    };
    updateCounters();
    setInterval(updateCounters, updateFrequency);
  });

}).call(this);
