// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  jQuery(function($) {
    return window.ScarcitySamuraiAddEditCounter = (function() {

      function ScarcitySamuraiAddEditCounter(counters) {
        this.counters = counters;
        this.$dialog = $('#add_edit_counter');
        this.addEditCounterEndpoint = $('#counters_wrapper').attr('add_edit_counter_endpoint');
        this.$accordion = $('.accordion', this.$dialog).accordion();
      }

      ScarcitySamuraiAddEditCounter.prototype.reset = function() {
        this.$dialog.find('[name]').removeClass('error').attr('title', '').tooltip();
        return this.$accordion.find('input').val('');
      };

      ScarcitySamuraiAddEditCounter.prototype.show = function(params) {
        var $content, accordionIndex,
          _this = this;
        this.reset();
        this.counterId = params.counterId;
        accordionIndex = (function() {
          switch (params.direction) {
            case 'up':
              return 0;
            case 'down':
              return 1;
            default:
              return null;
          }
        })();
        this.$accordion.accordion('open', {
          index: accordionIndex
        });
        $content = this.$accordion.find(".content[direction='" + params.direction + "']");
        if ($content.length === 1) {
          $content.find('.max').val(params.max);
          $content.find('.show_from').val(params.showFrom);
          $content.find('.thank_you_page').val(params.thankYouPage);
          $content.find('.expired_page').val(params.expiredPage);
        }
        this.$accordion.find('input').attr('tabindex', -1);
        this.$dialog.dialog({
          title: "" + (this.counterId != null ? 'Edit' : 'Add') + " Counter",
          width: 430,
          buttons: {
            OK: {
              text: 'OK',
              "class": 'ok scarcity_samurai_button',
              click: function(event) {
                if (!$(event.target).is('.disabled')) {
                  return _this.onOK();
                }
              }
            }
          }
        });
        return this.$okButton = this.$dialog.parents('.ui-dialog').find('.ok').attr('title', '').tooltip();
      };

      ScarcitySamuraiAddEditCounter.prototype.onOK = function() {
        var $content, counterData,
          _this = this;
        $content = this.$accordion.find('.content:visible');
        counterData = {
          counter_id: this.counterId,
          direction: $content.attr('direction'),
          max: $.trim($content.find('.max').val()),
          show_from: $.trim($content.find('.show_from').val()),
          thank_you_page: $.trim($content.find('.thank_you_page').val()),
          expired_page: $.trim($content.find('.expired_page').val())
        };
        return $.when(this.addEditCounter(counterData)).done(function(result) {
          _this.$dialog.find('[name]').removeClass('error').attr('title', '');
          switch (result.status) {
            case 'ok':
              _this.counters.updateUI(_this.counterId, result.counter_row_html);
              return _this.$dialog.dialog('close');
            case 'error':
              return _this.showErrors(result.errors);
          }
        });
      };

      ScarcitySamuraiAddEditCounter.prototype.addEditCounter = function(counterData) {
        var data;
        data = _.extend(counterData, this.counters.securityParams);
        return $.ajax({
          type: "POST",
          url: this.addEditCounterEndpoint,
          data: data,
          dataType: 'json'
        });
      };

      ScarcitySamuraiAddEditCounter.prototype.showErrors = function(errors) {
        var $field, error, focused, _i, _len;
        focused = false;
        for (_i = 0, _len = errors.length; _i < _len; _i++) {
          error = errors[_i];
          if (error.field_name != null) {
            $field = this.$dialog.find("[name='" + error.field_name + "']");
            $field.addClass('error').attr('title', error.error_message).tooltip('open');
            if (focused === false) {
              $field.focus();
              focused = true;
            }
          } else {
            this.$okButton.attr('title', error.error_message).tooltip('open');
          }
        }
      };

      return ScarcitySamuraiAddEditCounter;

    })();
  });

}).call(this);
