// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  jQuery(function($) {
    var ScarcitySamuraiInlineBanners;
    return ScarcitySamuraiInlineBanners = (function() {

      function ScarcitySamuraiInlineBanners() {
        var _this = this;
        this.$dialog = $('#ss-add-inline-banner-dialog');
        this.$bannerSelect = $('.ss-banner-select', this.$dialog);
        this.$bannerAction = $('[name="ss-inline-banner-action"]', this.$dialog);
        this.$bannerRedirectPageId = $('[name="ss-inline-banner-action-redirect-page-id"]', this.$dialog);
        this.$bannerRedirectURL = $('[name="ss-inline-banner-action-redirect-url"]', this.$dialog);
        this.update = null;
        this.$dialog.dialog({
          open: function() {
            var _ref;
            $('.ss-dialog-notice', _this.$dialog).toggle(_this.$dialog.data('campaign-id') === '');
            if (((_ref = _this.update) != null ? _ref.banner_id : void 0) != null) {
              _this.$dialog.dialog('option', 'title', 'Update Inline Banner');
              _this.renameButton('Add', 'Update');
              _this.$bannerSelect.select2('val', _this.update.banner_id);
              if (_this.update.banner_redirect_page_id != null) {
                _this.$bannerRedirectPageId.select2('val', _this.update.banner_redirect_page_id);
                return _this.$bannerAction.filter('input[value=redirect_to_page]').click();
              } else if (_this.update.banner_redirect_url != null) {
                _this.$bannerRedirectURL.val(_this.update.banner_redirect_url);
                return _this.$bannerAction.filter('[value=redirect_to_url]').click();
              } else {
                return _this.$bannerAction.filter('[value=do_nothing]').click();
              }
            } else {
              _this.$dialog.dialog('option', 'title', 'Add Inline Banner');
              return _this.renameButton('Update', 'Add');
            }
          },
          close: function() {
            return _this.update = null;
          },
          autoOpen: false,
          resizable: false,
          modal: true,
          width: 700,
          buttons: {
            'Cancel': function() {
              return $(this).dialog('close');
            },
            'Add': function() {
              var args, _ref;
              args = {
                banner_id: _this.$bannerSelect.select2('val'),
                banner_align: (_ref = _this.update) != null ? _ref.banner_align : void 0
              };
              switch (_this.$bannerAction.filter(':checked').val()) {
                case 'redirect_to_page':
                  args.banner_redirect_page_id = _this.$bannerRedirectPageId.select2('val');
                  break;
                case 'redirect_to_url':
                  args.banner_redirect_url = _this.$bannerRedirectURL.val();
              }
              _this.$dialog.dialog('close');
              _this.$dialog.trigger('add-banner');
              if ($('#content').is(':visible')) {
                return QTags.insertContent(ScarcitySamuraiHelper.inlineBannerHTMLComment(args));
              } else {
                return tinyMCE.execCommand('ssInsertInlineBanner', false, args);
              }
            }
          }
        });
        this.createApi();
        this.createBindings();
      }

      ScarcitySamuraiInlineBanners.prototype.renameButton = function(key, newKey) {
        var buttons;
        buttons = this.$dialog.dialog('option', 'buttons');
        if (buttons[key] != null) {
          buttons[newKey] = buttons[key];
          delete buttons[key];
          return this.$dialog.dialog('option', 'buttons', buttons);
        }
      };

      ScarcitySamuraiInlineBanners.prototype.createApi = function() {
        var _this = this;
        return _.extend(window.ssam || {}, {
          add_banner: function() {
            return _this.$dialog.dialog('open');
          },
          edit_banner: function(args) {
            _this.update = args;
            return _this.$dialog.dialog('open');
          }
        });
      };

      ScarcitySamuraiInlineBanners.prototype.createBindings = function() {
        var _this = this;
        return $('#ss-add-inline-banner-button').click(function() {
          return _this.$dialog.dialog('open');
        });
      };

      new ScarcitySamuraiInlineBanners();

      return ScarcitySamuraiInlineBanners;

    })();
  });

}).call(this);
