// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  jQuery(function($) {
    window.ScarcitySamuraiCounterGIFGenerator = (function() {

      function ScarcitySamuraiCounterGIFGenerator(counters) {
        var _this = this;
        this.counters = counters;
        this.$dialog = $('#counter_gif_generator_dialog');
        this.$tabs = $('.tabs', this.$dialog).tabs();
        this.$textTab = $('#counter_gif_generator_text_tab', this.$tabs);
        this.$counterTab = $('#counter_gif_generator_counter_tab', this.$tabs);
        this.$expiredTab = $('#counter_gif_generator_expired_tab', this.$tabs);
        this.$beforeText = $('.before_text', this.$dialog);
        this.$afterText = $('.after_text', this.$dialog);
        this.$generateLinkButton = $('.generate_link_button', this.$dialog);
        this.$copiedToClipboardConfirmation = $('.copied_to_clipboard_confirmation', this.$dialog);
        this.$gifWidth = $('.image_information .width', this.$dialog);
        this.$gifHeight = $('.image_information .height', this.$dialog);
        this.$preview = $('.preview', this.$dialog);
        this.$previewLoadingGIF = $('.loading_gif', this.$dialog);
        this.getGIFLinkEndpoint = this.$generateLinkButton.attr('endpoint');
        this._showPreview = ScarcitySamuraiHelper.deferredDebounce(function() {
          var deferred;
          deferred = $.Deferred();
          $.when(_this.preparePreviewLink()).done(function() {
            _this.$preview.attr('src', _this.previewLink).load(function() {
              _this.$previewLoadingGIF.hide();
              _this.$preview.show();
              _this.$gifWidth.text(_this.$preview.width());
              return _this.$gifHeight.text(_this.$preview.height());
            });
            return deferred.resolve();
          });
          return deferred.promise();
        }, 800);
        this.createBindings();
      }

      ScarcitySamuraiCounterGIFGenerator.prototype.createBindings = function() {
        var self,
          _this = this;
        self = this;
        $('.font_size_slider', this.$tabs).each(function() {
          var _this = this;
          return $(this).slider({
            min: 10,
            max: 50,
            value: parseInt($(this).attr('value')),
            step: 1,
            slide: function(event, ui) {
              $(_this).siblings('.font_size').text(ui.value);
              self.showPreview();
            }
          });
        });
        $('.color_picker_wrapper', this.$tabs).each(function() {
          return self.createColorPicker($(this));
        });
        $('.font_select', this.$tabs).change(function() {
          return _this.showPreview();
        });
        $('.expired_text', this.$tabs).keyup(function() {
          return _this.showPreview();
        });
        this.$beforeText.keyup(function() {
          return _this.showPreview();
        });
        this.$afterText.keyup(function() {
          return _this.showPreview();
        });
      };

      ScarcitySamuraiCounterGIFGenerator.prototype.createColorPicker = function($colorPickerWrapper) {
        var $colorPicker, $colorPickerPreview, self,
          _this = this;
        self = this;
        $colorPickerPreview = $('.color_picker_preview', $colorPickerWrapper);
        $colorPicker = $('.color_picker', $colorPickerWrapper);
        $colorPicker.hide().farbtastic(function(color) {
          $colorPickerPreview.css('background-color', color);
          _this.showPreview();
        });
        $.farbtastic($colorPicker).setColor($colorPicker.attr('default_color'));
        $colorPickerPreview.click(function() {
          if ($colorPicker.is(':hidden')) {
            $colorPicker.show();
          } else {
            $colorPicker.hide();
          }
        });
      };

      ScarcitySamuraiCounterGIFGenerator.prototype.reset = function() {
        this.$beforeText.val(this.$beforeText.attr("" + this.counterDirection + "_counter_default_value"));
        this.$afterText.val(this.$afterText.attr("" + this.counterDirection + "_counter_default_value"));
        $('.counter_text', this.$dialog).text(this.counterText);
        this.generatedLink = null;
      };

      ScarcitySamuraiCounterGIFGenerator.prototype.show = function(params) {
        var deferred,
          _this = this;
        this.counterId = params.counterId;
        this.counterDirection = params.counterDirection;
        this.counterText = params.counterText;
        this.reset();
        deferred = $.Deferred();
        this.$dialog.dialog({
          title: 'Counter GIF Generator',
          width: 701
        });
        this.$generateLinkButton.zclip({
          path: '../wp-content/plugins/scarcitysamurai/vendor/zclip/ZeroClipboard.swf',
          zIndex: 1100,
          copy: function() {
            return _this.generatedLink;
          },
          afterCopy: function() {
            _this.$copiedToClipboardConfirmation.show();
            setTimeout(function() {
              return _this.$copiedToClipboardConfirmation.fadeOut(1000);
            }, 5000);
          }
        });
        $.when(this.showPreview()).done(function() {
          deferred.resolve();
        });
        return deferred.promise();
      };

      ScarcitySamuraiCounterGIFGenerator.prototype.showPreview = function() {
        this.showLoadingGIF();
        this._showPreview();
      };

      ScarcitySamuraiCounterGIFGenerator.prototype.showLoadingGIF = function() {
        this.$preview.hide();
        this.$previewLoadingGIF.show();
      };

      ScarcitySamuraiCounterGIFGenerator.prototype.collectGIFParameters = function() {
        var afterText, beforeText, expiredText;
        this.params = {
          counter_id: this.counterId
        };
        beforeText = $.trim(this.$beforeText.val());
        afterText = $.trim(this.$afterText.val());
        if (beforeText.length > 0) {
          this.params['before_text'] = beforeText;
        }
        if (afterText.length > 0) {
          this.params['after_text'] = afterText;
        }
        if (beforeText.length > 0 || afterText.length > 0) {
          this.params['text_font'] = $('.font_select', this.$textTab).val();
          this.params['text_font_size'] = $('.font_size_slider', this.$textTab).slider('option', 'value');
          this.params['text_color'] = $.farbtastic($('.color_picker', this.$textTab)).color;
        }
        this.params['counter_font'] = $('.font_select', this.$counterTab).val();
        this.params['counter_font_size'] = $('.font_size_slider', this.$counterTab).slider('option', 'value');
        this.params['counter_color'] = $.farbtastic($('.color_picker', this.$counterTab)).color;
        expiredText = $.trim($('.expired_text', this.$expiredTab).val());
        if (expiredText.length > 0) {
          this.params['expired_text'] = expiredText;
          this.params['expired_font'] = $('.font_select', this.$expiredTab).val();
          this.params['expired_font_size'] = $('.font_size_slider', this.$expiredTab).slider('option', 'value');
          this.params['expired_color'] = $.farbtastic($('.color_picker', this.$expiredTab)).color;
        }
      };

      ScarcitySamuraiCounterGIFGenerator.prototype.preparePreviewLink = function() {
        var deferred,
          _this = this;
        deferred = $.Deferred();
        $.when(this.getGIFLink({
          cache: false
        }), this.getGIFLink({
          cache: true
        })).done(function(previewGIFLinkResult, realGIFLinkResult) {
          var previewGIFLink, realGIFLink;
          previewGIFLink = previewGIFLinkResult[0];
          realGIFLink = realGIFLinkResult[0];
          _this.previewLink = previewGIFLink;
          _this.generatedLink = realGIFLink;
          deferred.resolve();
        });
        return deferred.promise();
      };

      ScarcitySamuraiCounterGIFGenerator.prototype.getGIFLink = function(options) {
        this.collectGIFParameters();
        this.params = _.extend(this.params, options);
        this.params = _.extend(this.params, this.counters.securityParams);
        return $.ajax({
          type: "POST",
          url: this.getGIFLinkEndpoint,
          data: this.params,
          dataType: 'json'
        });
      };

      return ScarcitySamuraiCounterGIFGenerator;

    })();
  });

}).call(this);
