// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  jQuery(function($) {
    var ScarcitySamuraiCreateNewPageDialog;
    return ScarcitySamuraiCreateNewPageDialog = (function() {

      function ScarcitySamuraiCreateNewPageDialog() {
        var self,
          _this = this;
        self = this;
        this.$createNewPageLink = null;
        this.nonce = null;
        this.$dialog = $('#ss-create-new-page-dialog');
        this.$notice = $('.ss-dialog-notice', this.$dialog);
        this.$postType = $('.ss-page-type', this.$dialog);
        this.$postTitle = $('input[name="post_title"]', this.$dialog);
        this.$dialog.dialog({
          autoOpen: false,
          resizable: false,
          modal: true,
          width: 500,
          buttons: {
            'Cancel': function() {
              return $(this).dialog('close');
            },
            'Create': {
              text: 'Create',
              "class": 'ss-create-new-page-button',
              click: function() {
                return _this.createNewPage();
              }
            }
          }
        });
        this.createBindings();
      }

      ScarcitySamuraiCreateNewPageDialog.prototype.createBindings = function() {
        var self,
          _this = this;
        self = this;
        this.$postType.change(function() {
          return _this.$postTitle.focus();
        });
        this.$postTitle.keypress(function(event) {
          if (event.which === 13) {
            return _this.createNewPage();
          }
        });
        return $(document).on('click', '.ss-create-new-page-link', function(event) {
          event.preventDefault();
          self.$createNewPageLink = $(this);
          self.nonce = $(this).data('nonce');
          self.resetDialog();
          self.$dialog.dialog('open');
          return self.$postTitle.focus();
        });
      };

      ScarcitySamuraiCreateNewPageDialog.prototype.resetDialog = function() {
        this.$notice.hide();
        this.$postType.val('page');
        return this.$postTitle.val('');
      };

      ScarcitySamuraiCreateNewPageDialog.prototype.createNewPage = function() {
        var data;
        data = {
          post_type: this.$postType.val(),
          post_title: this.$postTitle.val(),
          nonce: this.nonce
        };
        return ssam.ajax('ss_create_new_page', {
          data: data,
          context: this,
          success: this.onSuccess,
          error: this.onFailure
        });
      };

      ScarcitySamuraiCreateNewPageDialog.prototype.onSuccess = function(response) {
        var $selectsToUpdate, id;
        id = response.id;
        $selectsToUpdate = $('.ss-page-select').not('.ss-page-select-template .ss-page-select');
        $selectsToUpdate.filter(':not([data-in-campaign])').each(function() {
          var selectedValue;
          selectedValue = $(this).select2('val');
          return $(this).html(response.page_select_options.all).select2('val', selectedValue);
        });
        $selectsToUpdate.filter('[data-in-campaign="false"]').each(function() {
          var selectedValue;
          selectedValue = $(this).select2('val');
          return $(this).html(response.page_select_options.not_in_campaign).select2('val', selectedValue);
        });
        this.$createNewPageLink.siblings('.ss-page-select').select2('val', id).change();
        this.$createNewPageLink = null;
        return this.$dialog.dialog('close');
      };

      ScarcitySamuraiCreateNewPageDialog.prototype.onFailure = function(message) {
        if (message == null) {
          message = 'Failed to create a new page.';
        }
        return this.$notice.text(message).show();
      };

      new ScarcitySamuraiCreateNewPageDialog();

      return ScarcitySamuraiCreateNewPageDialog;

    })();
  });

}).call(this);
