// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  jQuery(function($) {
    window.ScarcitySamuraiTimerGIFGenerator = (function() {

      function ScarcitySamuraiTimerGIFGenerator(campaignEdit) {
        var _this = this;
        this.campaignEdit = campaignEdit;
        this.$dialog = $('#timer_gif_generator_dialog');
        this.$tabs = $('.tabs', this.$dialog).tabs();
        this.$gifAutoResponderWrapper = $('.auto_responder_wrapper', this.$tabs);
        this.$gifAutoResponder = $('#gif_auto_responder', this.$tabs);
        this.$countForSlider = $('.count_for_slider', this.$tabs);
        this.$countFor = $('.count_for', this.$tabs);
        this.defaultSliderValue = parseInt(this.$countForSlider.attr('value'));
        this.$gifTextParameters = $('#gif_text_parameters', this.$tabs);
        this.$gifText = $('#gif_text', this.$tabs);
        this.$generateLinkButton = $('.generate_link_button', this.$dialog);
        this.$copiedToClipboardConfirmation = $('.copied_to_clipboard_confirmation', this.$dialog);
        this.$gifWidth = $('.image_information .width', this.$dialog);
        this.$gifHeight = $('.image_information .height', this.$dialog);
        this.$preview = $('.preview', this.$dialog);
        this.$previewLoadingGIF = $('.loading_gif', this.$dialog);
        this.getGIFLinkEndpoint = this.$generateLinkButton.attr('endpoint');
        this._showPreview = ScarcitySamuraiHelper.deferredDebounce(function() {
          var deferred;
          deferred = $.Deferred();
          $.when(_this.preparePreviewLink()).done(function() {
            _this.$preview.attr('src', _this.previewLink).load(function() {
              _this.$previewLoadingGIF.hide();
              _this.$preview.show();
              _this.$gifWidth.text(_this.$preview.width());
              return _this.$gifHeight.text(_this.$preview.height());
            });
            return deferred.resolve();
          });
          return deferred.promise();
        }, 800);
        this.createBindings();
      }

      ScarcitySamuraiTimerGIFGenerator.prototype.showLoadingGIF = function() {
        this.$preview.hide();
        this.$previewLoadingGIF.show();
      };

      ScarcitySamuraiTimerGIFGenerator.prototype.showPreview = function() {
        this.showLoadingGIF();
        this._showPreview();
      };

      ScarcitySamuraiTimerGIFGenerator.prototype.createBindings = function() {
        var self,
          _this = this;
        self = this;
        this.$gifAutoResponder.change(function() {
          return $.when(_this.showPreview()).done(function() {
            _this.updateGenerateLinkButton();
          });
        });
        $('[type="text"]', this.$tabs).keyup(function() {
          return _this.showPreview();
        });
        $('[type="checkbox"]', this.$tabs).click(function() {
          return _this.showPreview();
        });
        this.$countForSlider.slider({
          min: 0,
          max: 60,
          value: this.defaultSliderValue,
          step: 5,
          slide: function(event, ui) {
            _this.$countFor.text(ui.value);
            _this.showPreview();
          }
        });
        this.createColorPicker($('.timer_color', this.$dialog));
      };

      ScarcitySamuraiTimerGIFGenerator.prototype.createColorPicker = function($colorPickerWrapper) {
        var $colorPickerPreview, self,
          _this = this;
        self = this;
        $colorPickerPreview = $('.color_picker_preview', $colorPickerWrapper);
        this.$colorPicker = $('.color_picker', $colorPickerWrapper);
        this.$colorPicker.hide().farbtastic(function(color) {
          $colorPickerPreview.css('background-color', color);
          _this.showPreview();
        });
        $.farbtastic(this.$colorPicker).setColor(this.$colorPicker.attr('default_color'));
        $colorPickerPreview.click(function() {
          if (_this.$colorPicker.is(':hidden')) {
            _this.$colorPicker.show();
          } else {
            _this.$colorPicker.hide();
          }
        });
      };

      ScarcitySamuraiTimerGIFGenerator.prototype.paramsAreOK = function() {
        switch (this.type) {
          case 'opt_in':
            return this.$gifAutoResponder.val() !== '';
          case 'timestamp':
            return true;
        }
      };

      ScarcitySamuraiTimerGIFGenerator.prototype.updateGenerateLinkButton = function() {
        this.$generateLinkButton.toggleClass('disabled', !this.paramsAreOK());
      };

      ScarcitySamuraiTimerGIFGenerator.prototype.collectGIFParameters = function() {
        var text, timer_color;
        this.params = {};
        this.params['lifetime'] = this.$countForSlider.slider('option', 'value') + 1;
        timer_color = $.farbtastic(this.$colorPicker).color;
        if (timer_color != null) {
          this.params['timer_color'] = timer_color;
        }
        text = $.trim(this.$gifText.val());
        if (text.length > 0) {
          this.params['text'] = text;
        }
      };

      ScarcitySamuraiTimerGIFGenerator.prototype.buildGIFLink = function(link) {
        var encodedLink, m;
        switch (this.type) {
          case 'opt_in':
            switch (this.$gifAutoResponder.val()) {
              case 'aweber':
                return "" + link + "&token={!custom token}";
              case 'infusionsoft':
                m = link.match(/^(https?:\/\/)(.*)$/);
                encodedLink = m[1] + encodeURIComponent("" + m[2] + "&token=");
                return "" + encodedLink + "~Contact._token~";
              case 'sendpepper':
                return "" + link + "&token=[token]";
            }
            break;
          default:
            return link;
        }
      };

      ScarcitySamuraiTimerGIFGenerator.prototype.preparePreviewLink = function() {
        var deferred,
          _this = this;
        deferred = $.Deferred();
        if (this.paramsAreOK()) {
          $.when(this.getGIFLink(), this.getGIFLink(this.pageId)).done(function(previewGIFLinkResult, realGIFLinkResult) {
            var previewGIFLink, realGIFLink;
            previewGIFLink = previewGIFLinkResult[0];
            realGIFLink = realGIFLinkResult[0];
            _this.previewLink = previewGIFLink;
            _this.generatedLink = _this.buildGIFLink(realGIFLink);
            deferred.resolve();
          });
        } else {
          $.when(this.getGIFLink()).done(function(gifLink) {
            _this.previewLink = gifLink;
            deferred.resolve();
          });
        }
        return deferred.promise();
      };

      ScarcitySamuraiTimerGIFGenerator.prototype.getGIFLink = function(pageId) {
        this.collectGIFParameters();
        this.params = _.extend(this.params, this.campaignEdit.securityParams);
        if (pageId != null) {
          this.params = _.extend(this.params, {
            page_id: pageId
          });
        } else if (this.type === 'timestamp') {
          this.params = _.extend(this.params, {
            deadline: this.value,
            timezone: this.timezone
          });
        } else {
          this.params = _.extend(this.params, {
            time: 12 * 3600 + 34 * 60 + 56
          });
        }
        return $.ajax({
          type: "POST",
          url: this.getGIFLinkEndpoint,
          data: this.params,
          dataType: 'json'
        });
      };

      ScarcitySamuraiTimerGIFGenerator.prototype.show = function(params) {
        var deferred,
          _this = this;
        this.pageId = params.pageId;
        this.type = params.type;
        this.value = params.value;
        this.timezone = params.timezone;
        this.reset();
        this.updateGenerateLinkButton();
        deferred = $.Deferred();
        this.$dialog.dialog({
          title: 'Timer GIF Generator',
          width: 701
        });
        this.$generateLinkButton.zclip({
          path: '../wp-content/plugins/scarcitysamurai/vendor/zclip/ZeroClipboard.swf',
          zIndex: 1100,
          copy: function() {
            if (_this.$generateLinkButton.is('.disabled')) {
              return false;
            }
            return _this.generatedLink;
          },
          afterCopy: function() {
            _this.$copiedToClipboardConfirmation.show();
            setTimeout(function() {
              return _this.$copiedToClipboardConfirmation.fadeOut(1000);
            }, 5000);
          }
        });
        $.when(this.showPreview()).done(function() {
          deferred.resolve();
        });
        return deferred.promise();
      };

      ScarcitySamuraiTimerGIFGenerator.prototype.reset = function() {
        this.$gifAutoResponderWrapper.toggle(this.type === 'opt_in');
        this.$copiedToClipboardConfirmation.hide();
        this.$gifWidth.text('');
        this.$gifHeight.text('');
        return this.$preview.attr('src', '');
      };

      return ScarcitySamuraiTimerGIFGenerator;

    })();
  });

}).call(this);
