// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  jQuery(function($) {
    return window.ScarcitySamuraiHelper = (function() {

      function ScarcitySamuraiHelper() {}

      ScarcitySamuraiHelper.deferredDebounce = function(func, wait) {
        var timeout;
        timeout = null;
        return function() {
          var args, context, deferred, later;
          deferred = $.Deferred();
          context = this;
          args = arguments;
          later = function() {
            timeout = null;
            $.when(func.apply(context, args)).done(function() {
              deferred.resolve();
            });
          };
          clearTimeout(timeout);
          timeout = setTimeout(later, wait);
          deferred.promise();
        };
      };

      ScarcitySamuraiHelper.isNumber = function(str) {
        return /^\d+$/.test(str);
      };

      ScarcitySamuraiHelper.isValidURL = function(url) {
        var re;
        re = new RegExp('^(https?://)?([\\da-z\\.-]+)\\.([a-z\\.]{2,6})([/\\w \\.-]*)*/?', 'i');
        return re.test(url);
      };

      ScarcitySamuraiHelper.error = function(messages) {
        messages = _.map(messages, function(message) {
          return "\u2022 " + message;
        });
        messages.unshift("Please fix the following errors:\n");
        return alert(messages.join("\n"));
      };

      ScarcitySamuraiHelper.buildAttributesHTML = function(attributes) {
        var key, value;
        return ((function() {
          var _results;
          _results = [];
          for (key in attributes) {
            value = attributes[key];
            if (value != null) {
              _results.push("" + key + "=\"" + value + "\"");
            }
          }
          return _results;
        })()).join(' ');
      };

      ScarcitySamuraiHelper.inlineBannerHTMLComment = function(args) {
        var attributes;
        attributes = ScarcitySamuraiHelper.buildAttributesHTML({
          'id': args.banner_id,
          'align': args.banner_align,
          'redirect-page-id': args.banner_redirect_page_id,
          'redirect-url': args.banner_redirect_url
        });
        return "<!-- ss-banner " + attributes + " -->";
      };

      return ScarcitySamuraiHelper;

    })();
  });

}).call(this);
