// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  jQuery(function($) {
    var ScarcitySamuraiPageMetaBox;
    ScarcitySamuraiPageMetaBox = (function() {

      function ScarcitySamuraiPageMetaBox() {
        $('.ss-campaign-select').select2({
          width: '300px'
        });
        $('.ss-page-select').select2({
          placeholder: 'Select a page...',
          width: '300px'
        });
        $('.ss-timezone-select').select2({
          placeholder: 'Select a timezone...',
          width: '220px'
        });
        this.createBindings();
        this.checkLocation();
      }

      ScarcitySamuraiPageMetaBox.prototype.checkLocation = function() {
        var match;
        if ((match = window.location.hash.match(/^#(ss-page-(?:lock|timer|banners))$/))) {
          $("." + match[1] + "-tab a").click();
        }
        if (window.location.hash.match(/^#ss-/)) {
          _.delay(function() {
            return window.location.href = window.location.href;
          }, 500);
          return tinyMCE.onAddEditor.add(function(mgr, ed) {
            return ed.onPostRender.add(function(ed, cm) {
              if (ed.id === 'content') {
                return window.location.href = window.location.href;
              }
            });
          });
        }
      };

      ScarcitySamuraiPageMetaBox.prototype.createBindings = function() {
        var self,
          _this = this;
        self = this;
        $('#ss-page-tabs li a').click(function() {
          var $tab, tab;
          $tab = $(this).parent();
          $tab.addClass('tabs').removeClass('hide-if-no-js');
          $('#ss-page-tabs li').not($tab).removeClass('tabs').addClass('hide-if-no-js');
          tab = $tab.attr('class').match(/ss-page-([a-z-]*)-tab/);
          if (tab) {
            $('.ss-page-tab-panel').hide();
            $("#ss-page-" + tab[1] + "-tab-panel").show();
          }
          return false;
        }).eq(0).click();
        $('input.ss-enable').change(function() {
          return $(this).closest('div').find('div.ss-enable-block').toggle(this.checked);
        }).change();
        $('input.ul-radio').change(function() {
          if (!this.checked) {
            return;
          }
          $(this).closest('ul').find('div.ss-opts').hide();
          return $(this).closest('li').find('div.ss-opts').show();
        }).change();
        $('select.ss-page-campaign').change(function() {
          return $('.ss-page-campaign-page-opts').toggle(this.value !== '');
        }).change();
        $('input[name="ss-page-lock-from"]').change(function() {
          if (!this.checked) {
            return;
          }
          return $('.ss-page-lock-optin-only-opts').toggle(this.value === 'opt_in');
        }).change();
        $('input[name="ss-page-optin"]').change(function() {
          return $('.ss-page-optin-message-wrapper').toggle(this.checked);
        });
        $('[name="ss-page-lock-enable"], [name="ss-page-lock-from"]').change(function() {
          var showNotice;
          showNotice = $('[name="ss-page-lock-enable"]').is(':checked') && $('[name="ss-page-lock-from"]:checked').val() === 'opt_in';
          $('#ss-page-timer-optin-notice').toggle(showNotice);
          return $('#ss-page-timer-optin-warning').toggle(!showNotice);
        }).change();
        $('#ss-restrict-to-opt-ins-only').click(function() {
          var $accessRestrictionEnable, $accessRestrictionOptIn, $accessRestrictionOptInPage, $countDownTimerOptInPage;
          $accessRestrictionEnable = $('[name="ss-page-lock-enable"]');
          if (!$accessRestrictionEnable.is(':checked')) {
            $accessRestrictionEnable.click();
          }
          $accessRestrictionOptIn = $('[name="ss-page-lock-from"][value="opt_in"]');
          if (!$accessRestrictionOptIn.is(':checked')) {
            $accessRestrictionOptIn.click();
          }
          $accessRestrictionOptInPage = $('[name="ss-page-lock-from-optin-page-id"]');
          $countDownTimerOptInPage = $('[name="ss-page-timer-from-optin-page-id"]');
          $accessRestrictionOptInPage.val($countDownTimerOptInPage.val());
          $('[name="ss-page-lock-from-optin-days"]').val(0);
          $('[name="ss-page-lock-from-optin-hours"]').val(0);
          $('[name="ss-page-lock-from-optin-minutes"]').val(0);
          $('[name="ss-page-lock-from-optin-seconds"]').val(0);
          $('#ss-page-timer-optin-warning').hide();
          return $('#ss-page-timer-optin-notice').show();
        });
        $('[name="ss-page-counter-counter-id"]').change(function() {
          var counterId, counterLimit, upCounter;
          counterId = $(this).val();
          if (counterId === '') {
            $('#ss-counter-details').hide();
            return;
          }
          $('#ss-counter-details').show();
          upCounter = self.counters[counterId]['data']['direction'] === 'up';
          $('#ss-counter-details .ss-up-counter').toggle(upCounter);
          $('#ss-counter-details .ss-down-counter').toggle(!upCounter);
          counterLimit = (function() {
            switch (self.counters[counterId]['data']['direction']) {
              case 'up':
                return self.counters[counterId]['data']['max'];
              case 'down':
                return self.counters[counterId]['data']['min'];
            }
          })();
          $('#ss-counter-action').toggle(counterLimit != null);
          if (counterLimit != null) {
            return $('#ss-counter-action .ss-counter-limit').text(counterLimit);
          }
        }).change();
        $('[name="ss-page-header-banner-id"]').change(function() {
          var bannerId;
          bannerId = $(this).val();
          if (bannerId === '') {
            $('.ss-page-header-banner-click-action-wrapper').hide();
            return;
          }
          return $('.ss-page-header-banner-click-action-wrapper').show();
        }).change();
        $('[name="ss-page-footer-banner-id"]').change(function() {
          var bannerId;
          bannerId = $(this).val();
          if (bannerId === '') {
            $('.ss-page-footer-banner-click-action-wrapper').hide();
            return;
          }
          return $('.ss-page-footer-banner-click-action-wrapper').show();
        }).change();
        $('select.ss-page-campaign, [name="ss-page-timer-enable"]').change(this.updateBannerNotices).change();
        return $('#ss-add-inline-banner-dialog').on('add-banner', function() {
          $('#ss-add-inline-banner-button').data('has-inline-banners', 'yes');
          return _this.updateBannerNotices();
        });
      };

      ScarcitySamuraiPageMetaBox.prototype.updateBannerNotices = function() {
        var campaignId, hasInlineBanners, timerEnabled;
        hasInlineBanners = $('#ss-add-inline-banner-button').data('hasInlineBanners') === 'yes';
        campaignId = $('select.ss-page-campaign').val();
        timerEnabled = $('[name="ss-page-timer-enable"]').is(':checked');
        $('.ss-inline-banners-note-no-campaign').toggle(hasInlineBanners && campaignId === '');
        $('.ss-inline-banners-note-no-timer').toggle(hasInlineBanners && campaignId !== '' && !timerEnabled);
        return $('#ss-add-inline-banner-dialog').data('campaign-id', campaignId);
      };

      return ScarcitySamuraiPageMetaBox;

    })();
    return new ScarcitySamuraiPageMetaBox();
  });

}).call(this);
