// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  jQuery(function($) {
    var ScarcitySamuraiCounters;
    ScarcitySamuraiCounters = (function() {

      function ScarcitySamuraiCounters() {
        var $countersWrapper;
        this.securityParams = {
          security_token: $('[name="security_token"]').val(),
          _wp_http_referer: $('[name="_wp_http_referer"]').val()
        };
        $countersWrapper = $('#counters_wrapper');
        this.countersTable = $('#counters_table');
        this.deleteCounterEndpoint = $countersWrapper.attr('delete_counter_endpoint');
        this.incrementCounterEndpoint = $countersWrapper.attr('increment_counter_endpoint');
        this.addEditCounterDialog = new ScarcitySamuraiAddEditCounter(this);
        this.counterGIFGeneratorDialog = new ScarcitySamuraiCounterGIFGenerator(this);
        this.createBindings();
      }

      ScarcitySamuraiCounters.prototype.createBindings = function() {
        var self,
          _this = this;
        self = this;
        this.enableCopyToClipboard(this.countersTable);
        $(document).on('click', '#counters_table .actions .delete', function() {
          var counterId;
          counterId = $(this).parents('tr').attr('counter_id');
          return $.showConfirmationDialog({
            title: 'Delete Counter',
            width: 300,
            buttons: {
              Yes: {
                text: 'Yes',
                "class": 'scarcity_samurai_button',
                click: function() {
                  return self.deleteCounter(counterId);
                }
              }
            }
          });
        });
        $(document).on('click', '#counters_table .actions .gif', function() {
          var $row;
          $row = $(this).parents('tr');
          return self.counterGIFGeneratorDialog.show({
            counterId: $row.attr('counter_id'),
            counterDirection: $row.attr('direction'),
            counterText: $row.find('.display_value').attr('value')
          });
        });
        $(document).on('click', '#counters_table .actions .edit', function() {
          var $row;
          $row = $(this).parents('tr');
          return self.addEditCounterDialog.show({
            counterId: $row.attr('counter_id'),
            direction: $row.attr('direction'),
            max: $row.find('td.type .max').text(),
            showFrom: $row.find('td.show_from').attr('value'),
            thankYouPage: $row.find('td.thank_you_page a').attr('href'),
            expiredPage: $row.find('td.expired_page a').attr('href')
          });
        });
        $('.add_new_counter').click(function() {
          return _this.addEditCounterDialog.show({});
        });
      };

      ScarcitySamuraiCounters.prototype.deleteCounter = function(counterId) {
        var data, deleteCounterRequest,
          _this = this;
        data = {
          counter_id: counterId
        };
        data = _.extend(data, this.securityParams);
        deleteCounterRequest = $.ajax({
          type: "POST",
          url: this.deleteCounterEndpoint,
          data: data,
          dataType: 'json'
        });
        deleteCounterRequest.done(function(result) {
          switch (result.status) {
            case 'ok':
              $("tr[counter_id=" + counterId + "]", _this.countersTable).remove();
              _this.updateCountersTableVisibility();
              return $.hideConfirmationDialog();
          }
        });
      };

      ScarcitySamuraiCounters.prototype.enableCopyToClipboard = function($wrapper) {
        var self;
        self = this;
        $('.shortcode.scarcity_samurai_button', $wrapper).zclip({
          path: '../wp-content/plugins/scarcitysamurai/vendor/zclip/ZeroClipboard.swf',
          zIndex: 900,
          copy: function() {
            var counterId;
            counterId = $(this).parents('tr').attr('counter_id');
            return self.getShortcode(counterId);
          },
          afterCopy: function() {
            var $copiedToClipboardConfirmation;
            $copiedToClipboardConfirmation = $(this).siblings('.copied_to_clipboard').show();
            setTimeout(function() {
              return $copiedToClipboardConfirmation.fadeOut(1000);
            }, 5000);
          }
        });
        $('.increment_counter_link.scarcity_samurai_button', $wrapper).zclip({
          path: '../wp-content/plugins/scarcitysamurai/vendor/zclip/ZeroClipboard.swf',
          zIndex: 900,
          copy: function() {
            var counterId;
            counterId = $(this).parents('tr').attr('counter_id');
            return self.getIncrementCounterLink(counterId);
          },
          afterCopy: function() {
            var $copiedToClipboardConfirmation;
            $copiedToClipboardConfirmation = $(this).siblings('.copied_to_clipboard').show();
            setTimeout(function() {
              return $copiedToClipboardConfirmation.fadeOut(1000);
            }, 5000);
          }
        });
      };

      ScarcitySamuraiCounters.prototype.getShortcode = function(counterId) {
        return "[ss-counter id=\"" + counterId + "\"][/ss-counter]";
      };

      ScarcitySamuraiCounters.prototype.getIncrementCounterLink = function(counterId) {
        return "" + this.incrementCounterEndpoint + "?id=" + counterId;
      };

      ScarcitySamuraiCounters.prototype.updateUI = function(counterId, counterRowHTML) {
        var $newRow;
        $newRow = $(counterRowHTML);
        if (counterId != null) {
          $("tbody tr[counter_id='" + counterId + "']", this.countersTable).after($newRow).remove();
        } else {
          $('tbody', this.countersTable).append($newRow);
        }
        this.updateCountersTableVisibility();
        return this.enableCopyToClipboard($newRow);
      };

      ScarcitySamuraiCounters.prototype.updateCountersTableVisibility = function() {
        var rowsCount;
        rowsCount = this.countersTable.find('tbody tr').length;
        return this.countersTable.toggleClass('hidden', rowsCount === 0);
      };

      return ScarcitySamuraiCounters;

    })();
    new ScarcitySamuraiCounters();
  });

}).call(this);
