// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  jQuery(function($) {
    var ScarcitySamuraiSS_Timer;
    ScarcitySamuraiSS_Timer = (function() {

      function ScarcitySamuraiSS_Timer($timerWrapper) {
        var _this = this;
        this.$timerWrapper = $timerWrapper;
        if (this.$timerWrapper.attr('expires_after') == null) {
          return;
        }
        this.serverNow = parseInt(this.$timerWrapper.attr('now'));
        this.clientNow = this.getUnixTimestamp();
        this.serverTimeOffset = this.clientNow - this.serverNow;
        this.deadline = this.clientNow + parseInt(this.$timerWrapper.attr('expires_after'));
        this.value = this.updateTimer();
        this.intervalID = setInterval(function() {
          _this.value = _this.updateTimer();
          if (_this.value > 0) {
            return;
          }
          clearInterval(_this.intervalID);
          _this.onExpire();
        }, 1000);
      }

      ScarcitySamuraiSS_Timer.prototype.getUnixTimestamp = function() {
        return Math.round((new Date()).getTime() / 1000);
      };

      ScarcitySamuraiSS_Timer.prototype.updateTimer = function() {
        return Math.max(this.deadline - this.getUnixTimestamp() + this.serverTimeOffset, 0);
      };

      ScarcitySamuraiSS_Timer.prototype.onExpire = function() {
        var $elementsToHide, $elementsToShow, hideEffect, hideEffectDuration, showEffect, showEffectDuration;
        $elementsToShow = $(this.$timerWrapper.attr('show_elements'));
        $elementsToHide = $(this.$timerWrapper.attr('hide_elements'));
        showEffect = this.$timerWrapper.attr('show_effect');
        hideEffect = this.$timerWrapper.attr('hide_effect');
        showEffectDuration = this.$timerWrapper.attr('show_effect_duration') != null ? parseInt(this.$timerWrapper.attr('show_effect_duration')) : 1000;
        hideEffectDuration = this.$timerWrapper.attr('hide_effect_duration') != null ? parseInt(this.$timerWrapper.attr('hide_effect_duration')) : 1000;
        switch (showEffect) {
          case 'slide':
            $elementsToShow.slideDown(showEffectDuration);
            break;
          case 'fade':
            $elementsToShow.fadeIn(showEffectDuration);
            break;
          default:
            $elementsToShow.show();
        }
        switch (hideEffect) {
          case 'slide':
            return $elementsToHide.slideUp(hideEffectDuration);
          case 'fade':
            return $elementsToHide.fadeOut(hideEffectDuration);
          default:
            return $elementsToHide.hide();
        }
      };

      return ScarcitySamuraiSS_Timer;

    })();
    $('.ss-shortcode-timer-wrapper').each(function() {
      return new ScarcitySamuraiSS_Timer($(this));
    });
  });

}).call(this);
