// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  jQuery(function($) {
    var ScarcitySamuraiTimer, now, timerData, timerId, _ref;
    ScarcitySamuraiTimer = (function() {

      function ScarcitySamuraiTimer(timerId, timerData, serverNow) {
        var clientNow,
          _this = this;
        this.$timerWrapper = $(".ss-timer-" + timerId);
        this.$days = $('.ss-days', this.$timerWrapper);
        this.$hours = $('.ss-hours', this.$timerWrapper);
        this.$minutes = $('.ss-minutes', this.$timerWrapper);
        this.$seconds = $('.ss-seconds', this.$timerWrapper);
        this.styled = this.$timerWrapper.is('.ss-styled-timer');
        clientNow = this.getUnixTimestamp();
        this.serverTimeOffset = clientNow - serverNow;
        this.deadline = timerData.deadline;
        this.redirectURL = timerData.redirect_url;
        this.value = this.updateTimer();
        this.intervalID = setInterval(function() {
          _this.value = _this.updateTimer();
          if (_this.value > 0) {
            return;
          }
          clearInterval(_this.intervalID);
          _this.onExpire();
        }, 1000);
      }

      ScarcitySamuraiTimer.prototype.getUnixTimestamp = function() {
        return Math.round((new Date()).getTime() / 1000);
      };

      ScarcitySamuraiTimer.prototype.pluralize = function(count, word) {
        return count + ' ' + word + (count === 1 ? '' : 's');
      };

      ScarcitySamuraiTimer.prototype.updateTimer = function() {
        var days, hours, minutes, seconds, timerText, timerValue, value;
        timerValue = value = Math.max(this.deadline - this.getUnixTimestamp() + this.serverTimeOffset, 0);
        days = Math.floor(value / 86400);
        value -= days * 86400;
        hours = Math.floor(value / 3600);
        value -= hours * 3600;
        minutes = Math.floor(value / 60);
        value -= minutes * 60;
        seconds = value;
        if (this.styled) {
          this.$days.text((days < 10 ? '0' : '') + days);
          this.$hours.text((hours < 10 ? '0' : '') + hours);
          this.$minutes.text((minutes < 10 ? '0' : '') + minutes);
          this.$seconds.text((seconds < 10 ? '0' : '') + seconds);
        } else {
          timerText = days > 0 ? this.pluralize(days, 'day') : hours > 0 ? this.pluralize(hours, 'hour') : minutes > 0 ? this.pluralize(minutes, 'minute') : this.pluralize(seconds, 'second');
          this.$timerWrapper.text(timerText);
        }
        return timerValue;
      };

      ScarcitySamuraiTimer.prototype.onExpire = function() {
        if (this.redirectURL == null) {
          return;
        }
        window.onbeforeunload = null;
        window.location = this.redirectURL;
      };

      return ScarcitySamuraiTimer;

    })();
    now = parseInt(scarcitySamuraiData.now);
    if (scarcitySamuraiData.timer != null) {
      _ref = scarcitySamuraiData.timer;
      for (timerId in _ref) {
        timerData = _ref[timerId];
        new ScarcitySamuraiTimer(timerId, timerData, now);
      }
    }
    if (scarcitySamuraiData.end_time_timer != null) {
      new ScarcitySamuraiTimer(null, scarcitySamuraiData.end_time_timer, now);
    }
  });

}).call(this);
