// Generated by CoffeeScript 1.4.0

/*

LEGAL COPYRIGHT NOTICE

Copyright (c) Noble Samurai Pty Ltd, 2008-2013. All Rights Reserved.

This software is proprietary to and embodies the confidential technology of Noble Samurai Pty Ltd.
Possession, use, dissemination or copying of this software and media is authorised only pursuant
to a valid written license from Noble Samurai Pty Ltd. Questions or requests regarding permission may
be sent by email to legal@noblesamurai.com or by post to PO Box 477, Blackburn Victoria 3130, Australia.
*/


(function() {

  (function($) {
    tinymce.PluginManager.requireLangPack('scarcity');
    tinymce.create('tinymce.plugins.ScarcityPlugin', {
      /*
             Initializes the plugin, this will be executed after the plugin has been created.
             This call is done before the editor instance has finished it's initialization so use the onInit event
             of the editor instance to intercept that event.
      
             @param {tinymce.Editor} ed Editor instance that the plugin is initialized in.
             @param {string} url Absolute URL to where the plugin is located.
      */

      init: function(ed, url) {
        var bannerHTML, t;
        t = this;
        bannerHTML = "<img src='" + url + "/../../../images/tinymce/inline-banner-placeholder.png' class='mceItemNoResize ssBanner' />";
        t._url = url;
        ed.addCommand('ssContentBanner', function() {
          alert('TODO: banner configuration dialog');
          return ed.execCommand('mceInsertContent', false, bannerHTML);
        });
        ed.addButton('ssbanner', {
          title: 'Scarcity Banner',
          cmd: 'ssContentBanner',
          image: "" + url + "/../../../images/tinymce/logo.png"
        });
        ed.onPostRender.add(function() {
          if (!ed.theme.onResolveName) {
            return;
          }
          return ed.theme.onResolveName.add(function(th, o) {
            if ($(o.node).is('img.ssBanner')) {
              return o.name = 'ss-banner';
            }
          });
        });
        ed.onBeforeSetContent.add(function(ed, o) {
          if (o.content) {
            return o.content = o.content.replace(/\[ss-banner\]/g, bannerHTML);
          }
        });
        return ed.onPostProcess.add(function(ed, o) {
          if (!o.get) {
            return;
          }
          return o.content = $('<div />').html(o.content).find('img.ssBanner').replaceWith('[ss-banner]').end().html();
        });
      },
      /*
             Creates control instances based in the incomming name. This method is normally not
             needed since the addButton method of the tinymce.Editor class is a more easy way of adding buttons
             but you sometimes need to create more complex controls like listboxes, split buttons etc then this
             method can be used to create those.
      
             @param {String} n Name of the control to create.
             @param {tinymce.ControlManager} cm Control manager to use inorder to create new control.
             @return {tinymce.ui.Control} New control instance or null if no control was created.
      */

      createControl: function(n, cm) {
        var t;
        t = this;
        /*
              switch n
                when 'ssbanner'
                  c = cm.createSplitButton 'mysplitbutton',
                    title: 'Scarcity Banner'
                    image: "#{t._url}/../../../images/tinymce/icon.png"
                    cmd: 'ssContentBanner'
                  return c
        */

        return null;
      },
      /*
             Returns information about the plugin as a name/value array.
             The current keys are longname, author, authorurl, infourl and version.
      
             @return {Object} Name/value array containing information about the plugin.
      */

      getInfo: function() {
        return {
          longname: 'Scarcity Samurai Plugin',
          author: 'Noble Samurai',
          authorurl: 'http://www.noblesamurai.com/',
          infourl: 'http://www.noblesamurai.com/',
          version: '1.0'
        };
      }
    });
    return tinymce.PluginManager.add('scarcity', tinymce.plugins.ScarcityPlugin);
  })(jQuery);

}).call(this);
